if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Rules_GetAllNumbersForUserAndLines' ))
 	Drop procedure dbo.A_Rules_GetAllNumbersForUserAndLines
GO

Create Procedure dbo.A_Rules_GetAllNumbersForUserAndLines
as
begin
	Select np.Id as nid, np.Prefix, r.Id as rid, rr.InnerAddressType, rr.reactId
	From A_NumberPlan np
		Inner join A_NumberPlanAction npa on npa.NumId = np.id
		Inner join A_Rules r on npa.ExtraId = r.Id
		Inner join A_RuleRecords rr on rr.ruleid = r.Id
	Where npa.NumType = 0
		And rr.InnerAddressType in (0,1,2)
	Order by np.Prefix, r.Id	
end
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Line_GetAnalogIsUnderComputer' ))
 	Drop procedure dbo.A_Line_GetAnalogIsUnderComputer
GO

Create Procedure dbo.A_Line_GetAnalogIsUnderComputer
as
begin
	Select lr.LineId, wp.Id as wpid
	FROM A_LinesReactors lr 
		inner join A_WorkPlaces wp on lr.wpid = wp.id
		inner join A_ServerIntLines il on lr.LineId = il.Id
	where (lr.LineID != '00000000-0000-0000-0000-000000000000')
		and (wp.Type in (1,5))
	order by lr.LineId
end
GO
