
If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ServerSipLines' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerSipLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'Translit' )
	Alter Table oktell_settings.dbo.A_ServerSipLines
	Add [Translit] int default -1
GO

if Exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_ServerSipLines' ))
	Drop view dbo.A_ServerSipLines
GO

Create View dbo.A_ServerSipLines 
as
 	Select * 
	From oktell_settings.dbo.A_ServerSipLines
GO


if exists ( select * From sysobjects where id=object_id('dbo.A_Admin_Lines_Int_Get'))
	Drop procedure dbo.A_Admin_Lines_Int_Get	
GO

Create Procedure [dbo].A_Admin_Lines_Int_Get
	@id uniqueidentifier
as
begin
   --    .
   --  0  - 
   --    -   (  CTI)

   Declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
   Insert into @groups
	Select Id, Name 
	From A_Groups
   Insert Into @groups ( groupid, groupname )
	Values ( '00000000-0000-0000-0000-000000000000', '' )


   if ( @id = '00000000-0000-0000-0000-000000000000' )
   begin
	Select 
		e.Id,
		w.Name,
		w.Id,
		Cast ( e.SystemNum as nvarchar(20) ) as SystemNum,
		Cast ( e.Enabled as bit ) as Enabled,		
		Cast ( e.CityStraight as bit ) as CityStraight, 
		e.caption,
		e.ServerId,
		e.Type,
		e.ParentGroupId,
		g.GroupName,
		e.Address,
		e.StreamId,
		st.Name as StreamName,
		e.BusyMode,
		e.LineCode,
		e.Translit
	FROM 
	(	
		Select 	Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address,
			Cast ( NULL as uniqueidentifier ) as StreamId,
			Cast ( NULL as int ) as BusyMode,
			LineCode,
			Cast ( NULL as int ) as Translit
		From A_ServerIntLines

		Union All

		Select 	Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address,
			Cast ( NULL as uniqueidentifier ) as StreamId,
			Cast ( NULL as int ) as BusyMode,
			LineCode,
			Cast ( NULL as int ) as Translit
		From A_ServerUsbLines
		
		Union All

		Select 	Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			Address,
			StreamId,
			BusyMode,
			LineCode,
			Translit
		From A_ServerSipLines


		Union All

		Select 	Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			Address,
			Cast ( NULL as uniqueidentifier ) as StreamId,
			Cast ( NULL as int ) as BusyMode,
			LineCode,
			Cast ( NULL as int ) as Translit
		From A_ServerVirtualLines
	) e
	
		Inner join A_WorkPlaces w on e.ServerID = w.ID
		Inner join @groups g on e.ParentGroupId = g.GroupId
		Left join A_ServerStreams st on e.StreamId = st.Id

	Order By SystemNum
    
   end
   else
   begin
	
	Select 
		e.Id,
		w.Name,
		w.Id,
		Cast ( e.SystemNum as nvarchar(20) ) as SystemNum,
		Cast ( e.Enabled as bit ) as Enabled,		
		Cast ( e.CityStraight as bit ) as CityStraight, 
		e.caption,
		e.ServerId,
		e.Type,
		e.ParentGroupId,
		g.GroupName,
		e.Address,
		e.StreamId,
		st.Name as StreamName,
		e.BusyMode,
		e.LineCode
	
	FROM 
	(	
		Select 
			Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address,
			Cast ( NULL as uniqueidentifier ) as StreamId,
			Cast ( NULL as int ) as BusyMode,
			LineCode,
			Cast ( NULL as int ) as Translit
		From A_ServerIntLines
		
	) e
	
		Inner join A_WorkPlaces w on e.ServerID = w.ID
		Inner join @groups g on e.ParentGroupId = g.GroupId
		Left join A_ServerStreams st on e.StreamId = st.Id

	Where e.ServerId = @id
	Order By SystemNum
    end	

end
GO
