
---------------------------------------------
------- DIRECT SYNC table
---------------------------------------------

if exists ( select * from sysobjects where id=object_id ( 'dbo.A_TaskManager_List_DirectDB_SyncTableP' ))
	Drop procedure dbo.A_TaskManager_List_DirectDB_SyncTableP
GO

Create procedure A_TaskManager_List_DirectDB_SyncTableP
	@taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 500 ),
	@idfield nvarchar ( 50 ) = 'Id',
	@providername nvarchar(500) = 'SQLOLEDB',
	@connectstring nvarchar(4000) = ''
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ),
	@providername nvarchar(500),
	@connectstring nvarchar(4000)

Select @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF',
	@table = 'PROGRAMMER.oktell.dbo.T_X',
	@fields = 'id, name, phone1, phone2, dt',
	@idfield = 'id',
	@providername = 'SQLOLEDB',
	@connectstring = 'server=PROGRAMMER;database=oktell;uid=sa;pwd=123;'	
--*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			'

		exec sp_executesql @sql
	end	
	

	--     100000     transactionlog
	
	Set @sql = '			
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				Set @k = @k - 1

			if exists ( select * from tempdb..sysobjects where id=object_id(''tempdb..#tcache''))
				Drop table #tcache

			Select t.[' + @idfield + '] as idc into #tcache
			From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
				''Select [' + @idfield + '] From ' + @table + ' '' ) t 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( [Id], [AC], [State], [NIdx] )
				 	Select top 100000 [idc], @k, 0, 0
					From #tcache t 
					Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[idc] )
			end
			'

	--   STATE = 3    . (     )

	Set @sql = @sql + '

			Declare @cnta int
			Select @cnta = Count ( * ) 
			From #tcache
		
			Declare @cntb int
			Select @cntb = Count ( Id )
			From ' + @tableidx + '

			if ( @cnta < @cntb ) begin
				Update tac with ( tablock ) 
				Set State = 3
				From ' + @tableidx + ' tac 
				Where not exists ( Select idc From #tcache Where [idc] = tac.[Id] )
					and ( State != 3 )
			end

			Drop table #tcache
		'

	exec sp_executesql @sql

end
GO

---------------------------------------------
------- DIRECT SYNC table
---------------------------------------------

if exists ( select * from sysobjects where id=object_id ( 'dbo.A_TaskManager_List_DirectDB_SyncQueryP' ))
	Drop procedure dbo.A_TaskManager_List_DirectDB_SyncQueryP
GO

Create procedure dbo.A_TaskManager_List_DirectDB_SyncQueryP
	@taskid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 2000 ),
	@idfield nvarchar ( 100 ) = 'Id',
	@providername nvarchar(500) = 'SQLOLEDB',
	@connectstring nvarchar(4000) = ''
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ),
	@providername nvarchar(500),
	@connectstring nvarchar(4000)

Select @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF',
	@query = 'Select * From dbo.T_X Where id < 150000',
	@fields = 'id, name, phone1, phone2, dt',
	@idfield = 'id',
	@providername = 'SQLOLEDB',
	@connectstring = 'server=PROGRAMMER;database=oktell;uid=sa;pwd=123;'	
--*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'


	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			'

		exec sp_executesql @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				Set @k = @k - 1

			if exists ( select * from tempdb..sysobjects where id=object_id(''tempdb..#tcache''))
				Drop table #tcache

			Select t.[' + @idfield + '] as idc into #tcache
			From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
				''Select [' + @idfield + '] From ( ' + @query + ' )a'') t 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( [Id], [AC], [State], [NIdx] )				
				 	Select top 100000 [idc], @k, 0, 0
					From #tcache t
					Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[idc] )
			end
		'

	--   STATE = 3    . (     )
	
	Set @sql = @sql + '
			Declare @cnta int
			Select @cnta = Count ( * ) 
			From #tcache
		
			Declare @cntb int
			Select @cntb = Count ( Id )
			From ' + @tableidx + '
	
			if ( @cntb != @cnta ) begin
				Update t
				Set State = 3
				From ' + @tableidx + ' t
				Where not exists ( Select idc From #tcache Where idc = t.[Id] ) 
					and ( State != 3 )
			end

			Drop table #tcache
			'

	exec sp_executesql @sql

end
GO

---------------------------------------------
------- DIRECT GET table
---------------------------------------------

if exists ( select * from sysobjects where id = object_id ('dbo.A_TaskManager_List_DirectDB_GetTableP'))
	Drop procedure dbo.A_TaskManager_List_DirectDB_GetTableP
GO

Create procedure A_TaskManager_List_DirectDB_GetTableP
	@taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id',
	@providername nvarchar(500) = 'SQLOLEDB',
	@connectstring nvarchar(4000) = ''
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ),
	@providername nvarchar(500),
	@connectstring nvarchar(4000)

Select @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF',
	@table = 'PROGRAMMER.oktell.dbo.T_X',
	@fields = 'id, name, phone1, phone2, dt',
	@idfield = 'id',
	@providername = 'SQLOLEDB',
	@connectstring = 'server=PROGRAMMER;database=oktell;uid=sa;pwd=123;'	
--*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	Declare @sql nvarchar ( 4000 )

	--Set @sql = 'Drop table ' + @tableidx
	--exec sp_executesql @sql

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- c
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql

		--     100000     transactionlog
		Set @sql = '
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				Set @k = @k - 1

			if exists ( select * from tempdb..sysobjects where id=object_id(''tempdb..#tcache''))
				Drop table #tcache

			Select t.[' + @idfield + '] as idc into #tcache
			From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
				''Select [' + @idfield + '] From ' + @table + ' '' ) t 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( [Id], [AC], [State], [NIdx] )
				 	Select top 100000 [idc], @k, 0, 0
					From #tcache t 
					Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[idc] )
			end

			Drop table #tcache
			'

		exec sp_executesql @sql
	end	
	
	

	--       
	set @sql = ' 
		
		Declare @min int
		Select @min = Min ( AC ) 
		From ' + @tableidx + '  
		Where State = 0
		'
	--        ( )
	--          
	set @sql = @sql + '
		--     ,   -     
		begin tran search_update 

		Declare @id int, @efc int, @st int, @ln int
		Select top 1  @Id = Id, @efc = IsNull( AC, 0 ), @st = IsNull ( State, 0 ), @ln = IsNull ( NIdx, 0 )
		From ' + @tableidx + ' with ( Index ( [' + @tableacindex + '] ) )
		Where AC = @min
			and State = 0		

		Update ' + @tableidx + ' 
		Set AC = AC + 1, NIdx = NIdx + 1
		Where Id = @id

		commit tran search_update
		
		Select @id, @efc, @st, @ln
		'

	--        
	if exists ( select * from tempdb..sysobjects where id=object_id('tempdb..#tx'))
	    Drop table #tx
	Create table #tx ( id int, efc int, st int, ln int )

	Insert into #tx ( id, efc, st, ln )
	    exec sp_executesql @sql

	Declare @id int, @efc int, @st int, @ln int
	Select @id = id, @efc = efc, @st = st, @ln = ln 
	From #tx
	
	Drop table #tx
	
	--        
	set @sql = '
		Select ' + Cast ( @efc as nvarchar(10)) + ' as efc, ' + Cast ( @st as nvarchar(10)) + ' as st, ' + Cast ( @ln as nvarchar(10)) + ' as ln, ' + @fields + '
		From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
			''Select ' + @fields + ' From ' + @table + ' Where [' + @idfield + '] = ' + cast ( @id as nvarchar(10))+ ''') t 
		'

	exec sp_executesql @sql
end
GO

---------------------------------------------
------- DIRECT GET query
---------------------------------------------

if exists ( select * from sysobjects where id = object_id ('dbo.A_TaskManager_List_DirectDB_GetQueryP'))
	Drop procedure dbo.A_TaskManager_List_DirectDB_GetQueryP
GO

Create procedure A_TaskManager_List_DirectDB_GetQueryP
	@taskid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 2000 ),
	@idfield nvarchar ( 100 ) = 'Id',
	@providername nvarchar(500) = 'SQLOLEDB',
	@connectstring nvarchar(4000) = ''
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ),
	@providername nvarchar(500),
	@connectstring nvarchar(4000)

Select @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF',
	@query = 'Select * From dbo.T_X Where id < 150000',
	@fields = 'id, name, phone1, phone2, dt',
	@idfield = 'id',
	@providername = 'SQLOLEDB',
	@connectstring = 'server=PROGRAMMER;database=oktell;uid=sa;pwd=123;'	
--*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'

	Declare @sql nvarchar ( 4000 )

	--Set @sql = 'Drop table ' + @tableidx
	--exec sp_executesql @sql

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		-- c
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
		
		--     100000     transactionlog
		Set @sql = '			
			Declare @k int
			Set @k = 1
			Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
			if ( @k > 0 )
				Set @k = @k - 1

			if exists ( select * from tempdb..sysobjects where id=object_id(''tempdb..#tcache''))
				Drop table #tcache

			Select t.[' + @idfield + '] as idc into #tcache
			From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
				''Select [' + @idfield + '] From ( ' + @query + ' )a'') t 

			While ( @@rowcount > 0 )
			begin
				Insert into ' + @tableidx + ' ( [Id], [AC], [State], [NIdx] )				
				 	Select top 100000 [idc], @k, 0, 0
					From #tcache t
					Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[idc] )
			end
		
			Drop table #tcache
			'

		exec sp_executesql @sql
	end	
		

	--       
	set @sql = ' 
		Declare @min int
		Select @min = Min ( AC ) 
		From ' + @tableidx + '  
		Where State = 0
		'
	--        ( )
	--          
	set @sql = @sql + '
		--     ,   -     
		begin tran search_update_q

		Declare @id int, @efc int, @st int, @ln int
		Select top 1 @Id = Id, @efc = IsNull( AC, 0 ), @st = IsNull ( State, 0 ), @ln = IsNull ( NIdx, 0 )
		From ' + @tableidx + ' with ( Index ( [' + @tableacindex + '] ) )
		Where AC = @min
			and State = 0

		Update ' + @tableidx + ' 
		Set AC = AC + 1, NIdx = NIdx + 1
		Where Id = @id

		--Select @efc = IsNull( AC, 0 ), @st = IsNull ( State, 0 ), @ln = IsNull ( NIdx, 0 )
		--From ' + @tableidx + ' 
		--Where Id = @id

		commit tran search_update_q

		Select @id, @efc, @st, @ln
		'

	--        
	if exists ( select * from tempdb..sysobjects where id=object_id('tempdb..#tx'))
	    Drop table #tx
	Create table #tx ( id int, efc int, st int, ln int )

	Insert into #tx ( id, efc, st, ln )
	    exec sp_executesql @sql

	Declare @id int, @efc int, @st int, @ln int
	Select @id = id, @efc = efc, @st = st, @ln = ln 
	From #tx
	
	Drop table #tx
	
	--        
	set @sql = '
		Select ' + Cast ( @efc as nvarchar(10)) + ' as efc, ' + Cast ( @st as nvarchar(10)) + ' as st, ' + Cast ( @ln as nvarchar(10)) + ' as ln, ' + @fields + '
		From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
			''Select ' + @fields + ' From (' + @query + ')a Where [' + @idfield + '] = ' + cast ( @id as nvarchar(10))+ ''') t 
		'

	exec sp_executesql @sql

end
GO
