if exists ( Select * from sysobjects where id=object_id ('dbo.A_Stat_Office_Diagramm_AllCalls' ))
	Drop procedure dbo.A_Stat_Office_Diagramm_AllCalls
GO

Create procedure [dbo].[A_Stat_Office_Diagramm_AllCalls]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@conntype int = -1,
	@showconference int = 0,
	@showfailed int = 0,
	@mode int,
	@comment nvarchar(4000) = null,
	@idconn uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@idchain uniqueidentifier = '00000000-0000-0000-0000-000000000000'

as

begin
-- .  " "

/*
-- ---------------------------------------------------

Declare	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier,
	@fromcc bit,
	@operatorid uniqueidentifier,
	@innerprefix nvarchar ( 100 ),
	@outnumber nvarchar ( 100 ),
	@conntype int,
	@showconference int,
	@showfailed int,
	@mode int,
	@comment nvarchar(4000),
	@idconn uniqueidentifier,
	@idchain uniqueidentifier

Select @taskid = null,
	@fromcc = null,
	@operatorid = null,
	@innerprefix = null,
	@outnumber = null,
	@conntype = -1,
	@showconference = 0,
	@showfailed = 0,
	@comment = null,
	@idconn = '00000000-0000-0000-0000-000000000000',
	@idchain = '00000000-0000-0000-0000-000000000000'

Select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
	@dstart = 'Jan 18 2013 12:00:00:000AM', 
	@dstop = 'Jan 18 2013 11:59:59:963PM', 
	@tstart = 'Jul 26 2006  8:00:00:000AM', 
	@tstop = 'Jul 26 2006  9:00:00:000PM', 
	@lentime = 'Jul 26 2006 12:00:01:000AM', 
	@fromcc = 0, 
	@conntype = 2, 
	@comment = N'', 
	@mode = 4

*/

		
	Declare @id0 uniqueidentifier
	Set @id0 = '00000000-0000-0000-0000-000000000000'

	if exists ( select * from tempdb..sysobjects where id=object_id ( 'tempdb..#tempstatistics' ))
		Drop table #tempstatistics

	Select top 0 sc.*, 
		0 as IsConf, @id0 as Director, GetDate() as CTS, 
		0 as HasComment 
	Into #tempstatistics 
	From A_Stat_Connections_1x1 sc

		
	Insert into #tempstatistics 
	    Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber,
		@conntype,
		@showconference,
		@showfailed,
		@comment,
		@idconn,
		@idchain
	
	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			declare @k0 table ( idchain uniqueidentifier, timestop datetime )
			Insert into @k0
				Select IDChain, Max(TimeStop) as TimeStop
				From #tempstatistics							
				Group by IDChain

			Select Year ( timestop ) y, Month ( timestop ) m, Day ( timestop ) d, count ( * ) as Count_
			From @k0
			Group by Year ( timestop ), Month ( timestop ), Day ( timestop )
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			declare @k1 table ( idchain uniqueidentifier, timestop datetime )
			Insert into @k1
				Select IDChain, Max(TimeStop) as TimeStop
				From #tempstatistics
				Group by IDChain

			Select DatePart ( hour, timestop ) h, count ( * ) as Count_
			From @k1
			Group by DatePart ( hour, timestop )
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin							
			declare @lines2 table ( lineid uniqueidentifier )
			insert into @lines2
				Select Id From A_View_ServerLinesAll
	

			Select uid, sum ( count_ ) count_ from
			(
				Select AUserId as uid, count ( * ) as count_
				From #tempstatistics ts
					Inner Join A_Users u on u.Id = ts.AUserId
				Group by AUserId
			
				Union all
			
				Select BUserId as uid, count ( * ) as count_
				From #tempstatistics ts
					Inner Join A_Users u on u.Id = ts.BUserId
				Group By BUserId

				union

				Select AUserId as uid, count ( * ) as count_
				From #tempstatistics ts
					Inner Join @lines2 l on l.lineid = ts.BLineId
				Where ( ALineNum like 'IVR' )
				Group by AUserId

				Union all
					
				Select BUserId as uid, count ( * ) as count_
				From #tempstatistics ts
					Inner Join @lines2 l on l.lineid = ts.ALineId
				Where ( BLineNum like 'IVR' )
				Group By BUserId
	
			)a
			group by uid
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			--declare @lines3 table ( lineid uniqueidentifier )
			--Insert into @lines3
			--	Select Id From A_View_ServerLinesAll

			Declare @lines3 table ( lineid uniqueidentifier, caption nvarchar ( 100 ) collate database_default )
			Insert into @lines3 (lineid, caption)
				Select id, caption From A_View_ServerLinesAll

			
			Select linenum + case when (( not l.caption is NULL ) and ( l.caption != '' )) then ', ' + l.caption else '' end as linenum, 
				count_
			FROM (
				Select lineid, linenum, sum ( count_ ) count_ from
				(
					Select ALineId as lineid, ALineNum as linenum, count ( * ) as count_
					From #tempstatistics ts
						Inner Join @lines3 l on l.lineid = ts.ALineId	
					Group by ALineId, ALineNum
			
					Union all

					Select BLineId as lineid, BLineNum as linenum, 
						count ( * ) as count_
					From #tempstatistics ts
						Inner Join @lines3 l on l.lineid = ts.BLineId
					Group By BLineId, BLineNum

					Union all
	
					Select ALineId as lineid, ALineNum as linenum, count ( * ) as count_
					From #tempstatistics ts 
						Inner Join @lines3 l on l.lineid = ts.BLineId
					where ALineNum like 'IVR' 
					Group by ALineid, ALineNum

					Union all

					Select BLineId as lineid, BLineNum as linenum, count ( * ) as count_
					From #tempstatistics ts
						Inner Join @lines3 l on l.lineid = ts.ALineId
					where BLineNum like 'IVR'
					Group by BLineId, BLineNum
				)a				
				group by lineid, linenum
			)b
				Left join @lines3 l on b.lineid = l.lineid
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
	begin
		declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
		declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
		Insert Into @t
			Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
			From A_NumberPlan np
				Inner Join A_NumberPlanAction na on na.NumId = np.Id
				Inner Join A_Rules r on na.ExtraId = r.Id
				Inner Join A_RuleRecords rr on rr.RuleId = r.Id


		declare @cnt int
		set @cnt = 0

		while ( @@rowcount > 0 ) and ( @cnt < 10 )
		begin
			Set @cnt = @cnt + 1
	
			/*    @cnt - */
			Insert Into @temp
				Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
				From @t t
					Inner Join @t t1 on t.Reactid = t1.nId
				Where t.ReactId != t.Nid
	
			/*    */
			Delete From @t
				From @temp
			Where nid = id and reactid = oldrid

			/* */
			Insert Into @t ( nid, prefix, addrtype, reactid )
				Select id, prefix, addrtype, newrid From @temp

			/* */
			Delete From @temp	
		end

		declare @lines4 table ( lineid uniqueidentifier )
		insert into @lines4
			Select Id From A_View_ServerIntLinesAll



		if exists ( select * from tempdb..sysobjects where id=object_id('tempdb..#X'))
			Drop table #X
	
		Create table #X ( id uniqueidentifier, prefix nvarchar(50))

		Insert into #X ( id, prefix )
			Select t.id, t1.prefix
			From #tempstatistics t 
				Inner Join @t t1 on t1.reactid = t.AUserId and t1.addrtype = 0 
				Inner Join A_Users u on u.id = AUserId

		Insert into #X ( id, prefix )
			Select t.id, t1.prefix
			From #tempstatistics t 
				Inner Join @t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 
				Inner Join A_Users u on u.id = BUserId	
			Where not exists ( Select id from #X where t.id = id and t1.prefix = prefix )

		Insert into #X ( id, prefix )
			Select t.id, t1.prefix
			From #tempstatistics t 
				Inner Join @t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 
				Inner Join @lines4 l on l.lineid = ALineId
			Where not exists ( Select id from #X where t.id = id and t1.prefix = prefix )


		Insert into #X ( id, prefix )
			Select t.id, t1.prefix
			From #tempstatistics t 
				Inner Join @t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 
				Inner Join @lines4 l on l.lineid = BLineId
			Where not exists ( Select id from #X where t.id = id and t1.prefix = prefix )


		Select prefix, count ( * ) as count_
		From #X t
		Group by prefix		
		
	end
	--EStatisticsViewMode.svmByWeekDay:
	else if ( @mode = 5 )
		begin
			declare @k2 table ( idchain uniqueidentifier, timestop datetime )
			Insert into @k2
				Select IDChain, Max(TimeStop) as TimeStop
				From #tempstatistics
				Group by IDChain

			Select (DatePart(dw, TimeStop)+5)%7 WDay, count ( * ) as Count_
			From @k2
			Group by (DatePart(dw, TimeStop)+5)%7
			Order by WDay
		end

	Drop table #tempstatistics

end
GO


if exists ( Select * from sysobjects where id=object_id ('dbo.A_Stat_Office_Diagramm_AverageCallTime' ))
	Drop procedure dbo.A_Stat_Office_Diagramm_AverageCallTime
GO

Create procedure [dbo].[A_Stat_Office_Diagramm_AverageCallTime]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@conntype int = -1,
	@showconference int = 0,
	@showfailed int = 0,
	@mode int,
	@comment nvarchar(4000) = NULL,
	@idconn uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@idchain uniqueidentifier = '00000000-0000-0000-0000-000000000000'

as

begin
-- .  "  "

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	Select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 2
--------------------------------------------------------------------
*/

	Declare @id0 uniqueidentifier
	Set @id0 = '00000000-0000-0000-0000-000000000000'

	if exists ( select * from tempdb..sysobjects where id=object_id ( 'tempdb..#tempstatistics' ))
		Drop table #tempstatistics

	Select top 0 sc.*, 
		0 as IsConf, @id0 as Director, GetDate() as CTS, 
		0 as HasComment 
	Into #tempstatistics 
	From A_Stat_Connections_1x1 sc

		
	Insert into #tempstatistics 
	    Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber,
		@conntype,
		@showconference,
		@showfailed,
		@comment,
		@idconn,
		@idchain

	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			if not exists ( Select * From tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDdateInt') )
				Select top 0 Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, TimeStop - TimeAnswer length, 1 as count_
				into #tempstatisticsYMDdateInt
				From A_Stat_Connections_1x1
			else
				delete From #tempstatisticsYMDdateInt

			insert into #tempstatisticsYMDdateInt
				Select Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, Count ( * ) as count_
				From #tempstatistics
				Group By Year( Timestart ), Month ( TimeStart ), Day ( TimeStart )

			Select y, 
			m, 
			d,
			( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as [avg]
			into #tempstatYMDtabe
			From #tempstatisticsYMDdateInt
			Order by y,m,d
			
			select y,m,d,[avg]as [AverageSec],
					case 
					when floor([avg]/60) < 10 then ('0'+ cast(floor([avg]/60) as nvarchar (10)))
					when floor([avg]/60) >= 10 then (cast(floor([avg]/60) as nvarchar (10)))
					end		+ ':' + 			
					case 
					when floor([avg]) - floor([avg]/60)*60 < 10 then ('0'+cast(floor([avg]) - floor([avg]/60)*60 as nvarchar (10)))
					when floor([avg]) - floor([avg]/60)*60 >= 10 then (cast(floor([avg]) - floor([avg]/60)*60 as nvarchar (10)))
					end	
					as [Label]
			from #tempstatYMDtabe
			
			delete From #tempstatYMDtabe
			delete From #tempstatisticsYMDdateInt										
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			if not exists ( Select * From tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDHdateInt') )
				Select top 0 DatePart ( hh, TimeStart ) Hstart, TimeStop - TimeAnswer length, 1 as count_
				into #tempstatisticsYMDHdateInt
				From A_Stat_Connections_1x1
			else
				delete From #tempstatisticsYMDHdateInt

			insert into #tempstatisticsYMDHdateInt
				Select DatePart ( hh, TimeStart ) Hstart, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_
				From #tempstatistics
				Group By DatePart ( hh, TimeStart )

			Select Hstart, 
			( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as [avg]
			into #tempstatYMDHtabe
			From #tempstatisticsYMDHdateInt
			Order by Hstart
			
			select Hstart,[avg] as [AverageSec],
					case 
					when floor([avg]/60) < 10 then ('0'+ cast(floor([avg]/60) as nvarchar (10)))
					when floor([avg]/60) >= 10 then (cast(floor([avg]/60) as nvarchar (10)))
					end		+ ':' + 			
					case 
					when floor([avg]) - floor([avg]/60)*60 < 10 then ('0'+cast(floor([avg]) - floor([avg]/60)*60 as nvarchar (10)))
					when floor([avg]) - floor([avg]/60)*60 >= 10 then (cast(floor([avg]) - floor([avg]/60)*60 as nvarchar (10)))
					end	
					as [Label]
			from #tempstatYMDHtabe
			
			delete From #tempstatYMDHtabe

			delete From #tempstatisticsYMDHdateInt
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin	
			Select uid, 
			( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as [avg]
			into #tempstatOPPtabe
			From
			(
				Select uid, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_ From
				(
					Select AUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where AUserId != 'AB000000-0000-0000-0000-000000000000'
	
					Union all
	
					Select BUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where BUserId != 'AB000000-0000-0000-0000-000000000000'
				)a
				Group by uid
			)b
			
			select uid,[avg] as [AverageSec],
					case 
					when floor([avg]/60) < 10 then ('0'+ cast(floor([avg]/60) as nvarchar (10)))
					when floor([avg]/60) >= 10 then (cast(floor([avg]/60) as nvarchar (10)))
					end		+ ':' + 			
					case 
					when floor([avg]) - floor([avg]/60)*60 < 10 then ('0'+cast(floor([avg]) - floor([avg]/60)*60 as nvarchar (10)))
					when floor([avg]) - floor([avg]/60)*60 >= 10 then (cast(floor([avg]) - floor([avg]/60)*60 as nvarchar (10)))
					end	
					as [Label]
			from #tempstatOPPtabe
			
			delete From #tempstatOPPtabe
			
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			declare @lines3 table ( lineid uniqueidentifier, caption nvarchar ( 100 ) collate database_default )
			insert into @lines3 (lineid, caption)
				Select id, caption From A_View_ServerLinesAll


			Select linenum + case when (( not l.caption is NULL ) and ( l.caption != '' )) then ', ' + l.caption else '' end as linenum,
				( ( ( ( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as [avg]
			into #tempstatLINEtabe
			From
			(
				Select lineid, linenum, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length, count ( * ) as count_ From
				(
					Select ALineId as lineid, ALineNum as linenum, 
						TimeAnswer, TimeStop
					From #tempstatistics ts
					Inner Join @lines3 l on l.lineid = ts.ALineId
	
					Union all
	
					Select BLineId as lineid, BLineNum as linenum, 
						TimeAnswer, TimeStop
					From #tempstatistics ts
					Inner Join @lines3 l on l.lineid = ts.BLineId
				)a
				Group by lineid, linenum
			)b
				Left join @lines3 l on b.lineid = l.lineid
				
			select linenum,[avg] as [AverageSec],
					case 
					when floor([avg]/60) < 10 then ('0'+ cast(floor([avg]/60) as nvarchar (10)))
					when floor([avg]/60) >= 10 then (cast(floor([avg]/60) as nvarchar (10)))
					end		+ ':' + 			
					case 
					when floor([avg]) - floor([avg]/60)*60 < 10 then ('0'+cast(floor([avg]) - floor([avg]/60)*60 as nvarchar (10)))
					when floor([avg]) - floor([avg]/60)*60 >= 10 then (cast(floor([avg]) - floor([avg]/60)*60 as nvarchar (10)))
					end	
					as [Label]
			from #tempstatLINEtabe
			
			delete From #tempstatLINEtabe	
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
		begin
			declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
			declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
			Insert Into @t
				Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
				From A_NumberPlan np
					Inner Join A_NumberPlanAction na on na.NumId = np.Id
					Inner Join A_Rules r on na.ExtraId = r.Id
					Inner Join A_RuleRecords rr on rr.RuleId = r.Id


			declare @cnt int
			set @cnt = 0

			while ( @@rowcount > 0 ) and ( @cnt < 10 )
			begin
				Set @cnt = @cnt + 1
	
				/*    @cnt - */
				Insert Into @temp
					Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
					From @t t
						Inner Join @t t1 on t.Reactid = t1.nId
					Where t.ReactId != t.Nid
	
				/*    */
				Delete From @t
					From @temp
				Where nid = id and reactid = oldrid

				/* */
				Insert Into @t ( nid, prefix, addrtype, reactid )
					Select id, prefix, addrtype, newrid From @temp

				/* */
				Delete From @temp	
			end


			declare @lines4 table ( lineid uniqueidentifier )
			insert into @lines4
				Select Id From A_View_ServerLinesAll


			if exists ( select * from tempdb..sysobjects where id=object_id('tempdb..#X2'))
				Drop table #X2
	
			Create table #X2 ( id uniqueidentifier, prefix nvarchar(50), length float )

			Insert into #X2 ( id, prefix, length )
				Select t.id, t1.prefix, CAST ( t.TimeStop - t.TimeAnswer as float )
				From #tempstatistics t 
					Inner Join @t t1 on t1.reactid = t.AUserId and t1.addrtype = 0 
					Inner Join A_Users u on u.id = AUserId

			Insert into #X2 ( id, prefix, length )
				Select t.id, t1.prefix, CAST ( t.TimeStop - t.TimeAnswer as float )
				From #tempstatistics t 
					Inner Join @t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 
					Inner Join A_Users u on u.id = BUserId	
				Where not exists ( Select id from #X2 where t.id = id and t1.prefix = prefix )

			Insert into #X2 ( id, prefix, length )
				Select t.id, t1.prefix, CAST ( t.TimeStop - t.TimeAnswer as float )
				From #tempstatistics t 
					Inner Join @t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 
					Inner Join @lines4 l on l.lineid = ALineId
				Where not exists ( Select id from #X2 where t.id = id and t1.prefix = prefix )


			Insert into #X2 ( id, prefix, length )
				Select t.id, t1.prefix, CAST ( t.TimeStop - t.TimeAnswer as float )
				From #tempstatistics t 
					Inner Join @t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 
					Inner Join @lines4 l on l.lineid = BLineId
				Where not exists ( Select id from #X2 where t.id = id and t1.prefix = prefix )

			
			Select prefix, 
			(((( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) ) * 60 + DatePart ( mi, length ) ) * 60 + DatePart ( ss, length ) ) / count_ as [avg]
			into #tempstatNUMtabe
			From
			(
				Select prefix, Cast ( sum ( length ) as DateTime ) as length, count ( * ) as count_ 
				From #X2				
				Group by prefix
			)b
			
			select prefix,[avg] as [AverageSec],
					case 
					when floor([avg]/60) < 10 then ('0'+ cast(floor([avg]/60) as nvarchar (10)))
					when floor([avg]/60) >= 10 then (cast(floor([avg]/60) as nvarchar (10)))
					end		+ ':' + 			
					case 
					when floor([avg]) - floor([avg]/60)*60 < 10 then ('0'+cast(floor([avg]) - floor([avg]/60)*60 as nvarchar (10)))
					when floor([avg]) - floor([avg]/60)*60 >= 10 then (cast(floor([avg]) - floor([avg]/60)*60 as nvarchar (10)))
					end	
					as [Label]
			from #tempstatNUMtabe
			
			delete From #tempstatNUMtabe	

		end

	--EStatisticsViewMode.svmByWeekDay: // 
	else if ( @mode = 5 )
		begin
			if not exists ( Select * From tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDWDdateInt') )
				Select top 0 1 as WDay, CAST(1 as FLOAT) as Seconds, 1 as count_
				into #tempstatisticsYMDWDdateInt
				From A_Stat_Connections_1x1
			else
				delete From #tempstatisticsYMDWDdateInt


			insert into #tempstatisticsYMDWDdateInt
				select (DatePart(dw, TimeStart)+5)%7 as WDay, ISNULL(SUM(CAST(TimeStop-TimeAnswer as FLOAT))*86400,0) as Seconds, count(*) as count_ From #tempstatistics
				Group by (DatePart(dw, TimeStart)+5)%7
				Order by WDay


			Select WDay, 
			floor(Seconds/count_) as AverageSec
			,			case 
					when floor(Seconds/count_/60) < 10 then ('0'+ cast(floor(Seconds/count_/60) as nvarchar (10)))
					when floor(Seconds/count_/60) >= 10 then (cast(floor(Seconds/count_/60) as nvarchar (10)))
					end		+ ':' + 			
					case 
					when floor(Seconds/count_) - floor(Seconds/count_/60)*60 < 10 then ('0'+cast(floor(Seconds/count_) - floor(Seconds/count_/60)*60 as nvarchar (10)))
					when floor(Seconds/count_) - floor(Seconds/count_/60)*60 >= 10 then (cast(floor(Seconds/count_) - floor(Seconds/count_/60)*60 as nvarchar (10)))
					end	
					as [Label]
			From #tempstatisticsYMDWDdateInt
			order by WDay


			delete From #tempstatisticsYMDWDdateInt
		end
		
	Drop table #tempstatistics

end
GO


if exists ( Select * from sysobjects where id=object_id ('dbo.A_Stat_Office_Diagramm_CallTime' ))
	Drop procedure dbo.A_Stat_Office_Diagramm_CallTime
GO

Create procedure [dbo].[A_Stat_Office_Diagramm_CallTime]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@conntype int = -1,
	@showconference int = 0,
	@showfailed int = 0,
	@mode int,
	@comment nvarchar (4000) = NULL,
	@idconn uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@idchain uniqueidentifier = '00000000-0000-0000-0000-000000000000'
as

begin
-- .  " "

/*
-- ---------------------------------------------------
	declare @iduser uniqueidentifier
	declare @dstart datetime
	declare @dstop datetime
	declare @tstart datetime
	declare @tstop datetime
	declare @lentime datetime
	declare @taskid uniqueidentifier
	declare @operatorid uniqueidentifier
	declare @innerprefix nvarchar ( 100 )
	declare @outnumber nvarchar ( 100 )
	declare @mode int

	Select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
		@dstart = '15.06.2006', 
		@dstop = '20.12.2006', 
		@tstart = '8:00', 
		@tstop = '20:00', 
		@lentime = '0:00:01',
		@mode = 2
--------------------------------------------------------------------
*/
	Declare @id0 uniqueidentifier
	Set @id0 = '00000000-0000-0000-0000-000000000000'

	if exists ( select * from tempdb..sysobjects where id=object_id ( 'tempdb..#tempstatistics' ))
		Drop table #tempstatistics

	Select top 0 sc.*, 
		0 as IsConf, @id0 as Director, GetDate() as CTS, 
		0 as HasComment 
	Into #tempstatistics 
	From A_Stat_Connections_1x1 sc

		
	Insert into #tempstatistics 
	    Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber,
		@conntype,
		@showconference,
		@showfailed,
		@comment,
		@idconn,
		@idchain

	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			if not exists ( Select * From tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDdate') ) 
				Select top 0 Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, TimeStop - TimeAnswer length 
				into #tempstatisticsYMDdate 
				From A_Stat_Connections_1x1
			else
				delete From #tempstatisticsYMDdate

			insert into #tempstatisticsYMDdate
				Select Year( Timestart ) y, Month ( TimeStart ) m, Day ( TimeStart ) D, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length
				From #tempstatistics
				Group By Year( Timestart ), Month ( TimeStart ), Day ( TimeStart )


			Select y, m, d, 
			( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, 
			DatePart ( mi, length ) MI, 
			DatePart ( ss, length ) S, 
			DatePart ( ms, length ) MS,
			cast(( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) as nvarchar(4)) + 
			substring(convert(nvarchar(8),length,108), 3, 6) as Label
			From #tempstatisticsYMDdate
			Order by y,m,d
			
			delete From #tempstatisticsYMDdate										
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			if not exists ( Select * From tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDHdate') )
				Select top 0 DatePart ( hh, TimeStart ) Hstart, TimeStop - TimeAnswer length 
				into #tempstatisticsYMDHdate 
				From A_Stat_Connections_1x1
			else
				delete From #tempstatisticsYMDHdate

			insert into #tempstatisticsYMDHdate
				Select DatePart ( hh, TimeStart ) Hstart, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length
				From #tempstatistics
				Group By DatePart ( hh, TimeStart )

			Select Hstart, 
			( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, 
			DatePart ( mi, length ) MI, 
			DatePart ( ss, length ) S, 
			DatePart ( ms, length ) MS,
			cast(( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) as nvarchar(4)) + 
			substring(convert(nvarchar(8),length,108), 3, 6) as Label
			From #tempstatisticsYMDHdate

			delete From #tempstatisticsYMDHdate
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin			
			Select uid, 
			( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, 
			DatePart ( mi, length ) MI, 
			DatePart ( ss, length ) S, 
			DatePart ( ms, length ) MS,
			cast(( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) as nvarchar(4)) + 
			substring(convert(nvarchar(8),length,108), 3, 6) as Label
			From
			(
				Select uid, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length From
				(
					Select AUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where AUserId != 'AB000000-0000-0000-0000-000000000000'
	
					Union all
	
					Select BUserId as uid, TimeAnswer, TimeStop
					From #tempstatistics
					Where BUserId != 'AB000000-0000-0000-0000-000000000000'
				)a
				Group by uid
			)b			
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			declare @lines table ( lineid uniqueidentifier, caption nvarchar ( 100 ) collate database_default )
			insert into @lines (lineid, caption)
				Select id, caption From A_View_ServerLinesAll


			Select linenum + case when (( not l.caption is NULL ) and ( l.caption != '' )) then ', ' + l.caption else '' end as linenum,
				( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, 
				DatePart ( mi, length ) MI, 
				DatePart ( ss, length ) S, 
				DatePart ( ms, length ) MS,
			cast(( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) as nvarchar(4)) + 
			substring(convert(nvarchar(8),length,108), 3, 6) as Label
			From
			(
				Select lineid, linenum, Cast ( sum ( CAST ( TimeStop - TimeAnswer as float ) ) as DateTime ) length From
				(
					Select ALineId as lineid, ALineNum as linenum, 
						TimeAnswer, TimeStop
					From #tempstatistics ts
					Inner Join @lines l on l.lineid = ts.ALineId
	
					Union all
	
					Select BLineId as lineid, BLineNum as linenum, 
						TimeAnswer, TimeStop
					From #tempstatistics ts
					Inner Join @lines l on l.lineid = ts.BLineId
				)a
				Group by lineid, linenum
			)b
				Left join @lines l on b.lineid = l.lineid
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
		begin
			declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
			declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
			Insert Into @t
				Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
				From A_NumberPlan np
					Inner Join A_NumberPlanAction na on na.NumId = np.Id
					Inner Join A_Rules r on na.ExtraId = r.Id
					Inner Join A_RuleRecords rr on rr.RuleId = r.Id


			declare @cnt int
			set @cnt = 0

			while ( @@rowcount > 0 ) and ( @cnt < 10 )
			begin
				Set @cnt = @cnt + 1
	
				/*    @cnt - */
				Insert Into @temp
					Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
					From @t t
						Inner Join @t t1 on t.Reactid = t1.nId
					Where t.ReactId != t.Nid
	
				/*    */
				Delete From @t
					From @temp
				Where nid = id and reactid = oldrid

				/* */
				Insert Into @t ( nid, prefix, addrtype, reactid )
					Select id, prefix, addrtype, newrid From @temp

				/* */
				Delete From @temp	
			end


			declare @lines4 table ( lineid uniqueidentifier )
			insert into @lines4
				Select Id From A_View_ServerLinesAll
	


			if exists ( select * from tempdb..sysobjects where id=object_id('tempdb..#X3'))
				Drop table #X3
	
			Create table #X3 ( id uniqueidentifier, prefix nvarchar(50), length float )

			Insert into #X3 ( id, prefix, length )
				Select t.id, t1.prefix, CAST ( t.TimeStop - t.TimeAnswer as float )
				From #tempstatistics t 
					Inner Join @t t1 on t1.reactid = t.AUserId and t1.addrtype = 0 
					Inner Join A_Users u on u.id = AUserId

			Insert into #X3 ( id, prefix, length )
				Select t.id, t1.prefix, CAST ( t.TimeStop - t.TimeAnswer as float )
				From #tempstatistics t 
					Inner Join @t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 
					Inner Join A_Users u on u.id = BUserId	
				Where not exists ( Select id from #X3 where t.id = id and t1.prefix = prefix )

			Insert into #X3 ( id, prefix, length )
				Select t.id, t1.prefix, CAST ( t.TimeStop - t.TimeAnswer as float )
				From #tempstatistics t 
					Inner Join @t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 
					Inner Join @lines4 l on l.lineid = ALineId
				Where not exists ( Select id from #X3 where t.id = id and t1.prefix = prefix )


			Insert into #X3 ( id, prefix, length )
				Select t.id, t1.prefix, CAST ( t.TimeStop - t.TimeAnswer as float )
				From #tempstatistics t 
					Inner Join @t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 
					Inner Join @lines4 l on l.lineid = BLineId
				Where not exists ( Select id from #X3 where t.id = id and t1.prefix = prefix )


			Select prefix, 
			( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) H, 
			DatePart ( mi, length ) MI, 
			DatePart ( ss, length ) S, 
			DatePart ( ms, length ) MS,
			cast(( DatePart ( dy, length ) - 1 ) * 24 + DatePart ( hh, length ) as nvarchar(4)) + 
			substring(convert(nvarchar(8),length,108), 3, 6) as Label
			From
			(
				Select prefix, Cast ( sum ( length ) as DateTime ) as length
				From #X3
				Group by prefix
			)c

		end
	--EStatisticsViewMode.svmByWeekDay:
	else if ( @mode = 5 )
		begin
			--drop table #tempstatisticsYMDWDdateInt
 			if not exists ( Select * From tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsYMDWDdateInt') )
				Select top 0 1 as WDay, CAST(1 as FLOAT) as Seconds, 1 as count_
				into #tempstatisticsYMDWDdateInt
				From A_Stat_Connections_1x1
			else
				delete From #tempstatisticsYMDWDdateInt


			insert into #tempstatisticsYMDWDdateInt
				select (datepart(dw, TimeStart)+5)%7 as WDay, ISNULL(SUM(CAST(TimeStop-TimeAnswer as FLOAT))*86400,0) as Seconds, count(*) as count_ From #tempstatistics
				Group By (datepart(dw, TimeStart)+5)%7
				Order By (datepart(dw, TimeStart)+5)%7


			Select WDay, 
			Seconds  as AverageSec,
			case
				when cast(floor(Seconds/3600) as nvarchar (10)) < 10 then ('0'+cast(floor(Seconds/3600) as nvarchar (10)))
				when cast(floor(Seconds/3600) as nvarchar (10)) >= 10 then (cast(floor(Seconds/3600) as nvarchar (10)))		
			end	
			+ ':' + 
			case 
				when floor(Seconds/60) - floor(Seconds/3600)*60 < 10 then ('0'+cast(floor(Seconds/60) - floor((Seconds)/3600)*60 as nvarchar (10)))
				when floor(Seconds/60) - floor(Seconds/3600)*60 >= 10 then (cast(floor(Seconds/60) - floor((Seconds)/3600)*60 as nvarchar (10)))
			end 
			+':'+
			case 
				when floor(Seconds) - floor(Seconds/60)*60 < 10 then ('0'+cast(floor(Seconds) - floor((Seconds)/60)*60 as nvarchar (10)))
				when floor(Seconds) - floor(Seconds/60)*60 >= 10 then (cast(floor(Seconds) - floor((Seconds)/60)*60 as nvarchar (10)))
			end 			
			 as Label
			From #tempstatisticsYMDWDdateInt


			delete From #tempstatisticsYMDWDdateInt
		end

	Drop table #tempstatistics

end
GO


if exists ( Select * from sysobjects where id=object_id ('dbo.A_Stat_Office_Diagramm_FlashedCalls' ))
	Drop procedure dbo.A_Stat_Office_Diagramm_FlashedCalls
GO

Create procedure [dbo].[A_Stat_Office_Diagramm_FlashedCalls]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@conntype int = -1,
	@showconference int = 0,
	@showfailed int = 0,
	@mode int,
	@comment nvarchar ( 4000 ) = NULL,
	@idconn uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@idchain uniqueidentifier = '00000000-0000-0000-0000-000000000000'
as

begin
-- .  "  "

/*
-- ---------------------------------------------------

Declare @iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier,
	@fromcc bit,
	@operatorid uniqueidentifier,
	@innerprefix nvarchar(100),
	@outnumber nvarchar(100),
	@conntype int,
	@showconference bit,
	@showfailed bit,
	@comment nvarchar ( 4000 ),
	@idconn uniqueidentifier,
	@idchain uniqueidentifier,
	@mode int

Select  @taskid = NULL, --Task defined
	@fromcc = NULL,
	@operatorid = NULL, --Operator defined
	@innerprefix = NULL, --Internal Number defined
	@outnumber = NULL,  --Out Number defined
	@conntype = -1,
	@showconference = 0,
	@showfailed = 0,
	@comment = NULL,
	@idconn = '00000000-0000-0000-0000-000000000000',
	@idchain = '00000000-0000-0000-0000-000000000000',
	@mode = 0

Select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', 
	@dstart = 'Dec 26 2012 12:00:00:000AM', 
	@dstop = 'Dec 26 2012 11:59:59:963PM', 
	@tstart = 'Jul 26 2006 12:42:00:000AM', 
	@tstop = 'Jul 26 2006 10:27:00:000PM', 
	@lentime = 'Jul 26 2006 12:00:00:000AM', 
	@fromcc = 0, 
	@conntype = -1, 
	@comment = N'',
	@showconference = 1,
	@showfailed = 0

*/

--------------------------------------------------------------------


	Declare @id0 uniqueidentifier
	Set @id0 = '00000000-0000-0000-0000-000000000000'

	if exists ( select * from tempdb..sysobjects where id=object_id ( 'tempdb..#tempstatistics' ))
		Drop table #tempstatistics

	Select top 0 sc.*, 
		0 as IsConf, @id0 as Director, GetDate() as CTS, 
		0 as HasComment 
	Into #tempstatistics 
	From A_Stat_Connections_1x1 sc

		
	Insert into #tempstatistics 
	    Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber,
		@conntype,
		@showconference,
		@showfailed,
		@comment,
		@idconn,
		@idchain

	if exists ( Select * From tempdb..sysobjects where id = object_id('tempdb..#tempstatisticsflash') )
		Drop table #tempstatisticsflash

	Select top 0 sc1.*, sc2.ALineId A2LineId, sc2.BLineId B2LineId 
	Into #tempstatisticsflash
	From #tempstatistics sc1 --A_Stat_Connections_1x1 sc1 
		Inner Join A_Stat_Connections_1x1 sc2 on sc1.IDNext = sc2.Id

	Insert into #tempstatisticsflash
		Select ts1.*, ts2.ALineId A2LineId, ts2.BLineId B2LineId
		From #tempstatistics ts1 Inner Join 
			#tempstatistics ts2 on ts1.idnext = ts2.id
		Where not ( ts1.ALineId = ts2.ALineId and ts1.BLineID = ts2.BLineId ) 
			and not ( ts1.ALineId = ts2.BLineId and ts1.BLineID = ts2.ALineId )
			and not ( ts1.AUserId = 'AB000000-0000-0000-0000-000000000000' )
			and not ( ts1.BUserId = 'AB000000-0000-0000-0000-000000000000' )


	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			Select Year ( timestop ) y, Month ( timestop ) m, Day ( timestop ) d, count ( * ) as Count_
			From #tempstatisticsflash
			Group by Year ( timestop ), Month ( timestop ), Day ( timestop )											
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			Select DatePart ( hour, timestop ) h, count ( * ) as Count_
			From #tempstatisticsflash
			Group by DatePart ( hour, timestop )
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin							
			Select uid, count ( * ) as count_
			From
			( 
				Select AUserId as uid, TimeStop
				From #tempstatisticsflash
				where StopSide = 0 and 
					(AUserId != '00000000-0000-0000-0000-000000000000')
		
				Union all

				Select BUserId as uid, TimeStop
				From #tempstatisticsflash
				where StopSide = 1 and
					(BUserId != '00000000-0000-0000-0000-000000000000')
			)a
			Group by uid								
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin			
			declare @lines table ( lineid uniqueidentifier, caption nvarchar ( 100 ) collate database_default )
			insert into @lines (lineid, caption)
				Select id, caption From A_View_ServerLinesAll											
			
			Select linenum + case when (( not l.caption is NULL ) and ( l.caption != '' )) then ', ' + l.caption else '' end as linenum,
				count_
			From
			(
				Select lineid, linenum, count ( * ) as count_
				from
				(
					Select BLineNum as lineid, BLineNum linenum, TimeStop
					From #tempstatisticsflash ts 
					Inner Join @lines l on ts.BLineId = l.lineid

					union
	
					Select ALineNum as lineid, ALineNum linenum, TimeStop
					From #tempstatisticsflash ts 
					Inner Join @lines l on ts.ALineId = l.lineid
				)a
				group by lineid, linenum
			)
			b
				Left join @lines l on b.lineid = l.lineid
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
		begin
			declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
			declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
			Insert Into @t
				Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
				From A_NumberPlan np
					Inner Join A_NumberPlanAction na on na.NumId = np.Id
					Inner Join A_Rules r on na.ExtraId = r.Id
					Inner Join A_RuleRecords rr on rr.RuleId = r.Id


			declare @cnt int
			set @cnt = 0

			while ( @@rowcount > 0 ) and ( @cnt < 10 )
			begin
				Set @cnt = @cnt + 1
	
				/*    @cnt - */
				Insert Into @temp
					Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
					From @t t
						Inner Join @t t1 on t.Reactid = t1.nId
					Where t.ReactId != t.Nid
	
				/*    */
				Delete From @t
					From @temp
				Where nid = id and reactid = oldrid

				/* */
				Insert Into @t ( nid, prefix, addrtype, reactid )
					Select id, prefix, addrtype, newrid From @temp

				/* */
				Delete From @temp	
			end

			declare @lines4 table ( lineid uniqueidentifier )
			insert into @lines4
				Select Id From A_View_ServerIntLinesAll


			if exists ( select * from tempdb..sysobjects where id=object_id('tempdb..#X4'))
				Drop table #X4
	
			Create table #X4 ( id uniqueidentifier, prefix nvarchar(50))

			Insert into #X4 ( id, prefix )
				Select t.id, t1.prefix
				From #tempstatisticsflash t 
					Inner Join @t t1 on t1.reactid = t.AUserId and t1.addrtype = 0 
					Inner Join A_Users u on u.id = AUserId

			Insert into #X4 ( id, prefix )
				Select t.id, t1.prefix
				From #tempstatisticsflash t 
					Inner Join @t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 
					Inner Join A_Users u on u.id = BUserId	
				Where not exists ( Select id from #X4 where t.id = id and t1.prefix = prefix )

			Insert into #X4 ( id, prefix )
				Select t.id, t1.prefix
				From #tempstatisticsflash t 
					Inner Join @t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 
					Inner Join @lines4 l on l.lineid = ALineId
				Where not exists ( Select id from #X4 where t.id = id and t1.prefix = prefix )


			Insert into #X4 ( id, prefix )
				Select t.id, t1.prefix
				From #tempstatisticsflash t 
					Inner Join @t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 
					Inner Join @lines4 l on l.lineid = BLineId
				Where not exists ( Select id from #X4 where t.id = id and t1.prefix = prefix )


			Select prefix, Count ( * ) count_ 
			From #X4			
			Group by prefix

		end
	--EStatisticsViewMode.svmByWeekDay:
	else if ( @mode = 5 )
		begin
			Select (DatePart(dw, TimeStart)+5)%7 as WDay, count(*) as count_
			From #tempstatisticsflash
			Group by (DatePart(dw, TimeStart)+5)%7
			Order by WDay
		end

	Drop table #tempstatisticsflash
	Drop table #tempstatistics

end
GO