
if exists ( Select * from oktell_settings..sysobjects where id=object_id ('oktell_settings.dbo.A_PermittedNumbers' ))
 	Drop table oktell_settings.dbo.A_PermittedNumbers
GO

Create table oktell_settings.dbo.A_PermittedNumbers
(
	[id] int identity (1,1) primary key, 
	[number] nvarchar(50) collate database_default
)
GO

use oktell_settings
if exists (select * from dbo.sysindexes where name = N'idx_PermittedNumber' and id = object_id(N'oktell_settings.[dbo].[A_PermittedNumbers]'))
drop index [dbo].[A_PermittedNumbers].[idx_PermittedNumber]
GO

use oktell_settings
CREATE INDEX [idx_PermittedNumber] ON oktell_settings.[dbo].[A_PermittedNumbers]([number]) WITH FILLFACTOR = 80 ON [PRIMARY]
GO

use oktell
GO

if exists ( Select * from sysobjects where id=object_id ('dbo.A_PermittedNumbers' ) and OBJECTPROPERTY(id, N'IsView') = 1)
 	Drop view dbo.A_PermittedNumbers
GO

Create VIEW dbo.A_PermittedNumbers
As
	Select *
	FROM oktell_settings.dbo.A_PermittedNumbers
GO


if exists ( Select * from sysobjects where id= object_id('dbo.A_PermittedNumbers_GetAll'))
	Drop procedure dbo.A_PermittedNumbers_GetAll
GO

Create procedure dbo.A_PermittedNumbers_GetAll
as
Begin
	Select number
	From A_PermittedNumbers
End
GO


if exists ( Select * from sysobjects where id= object_id('dbo.A_PermittedNumbers_Search'))
	Drop procedure dbo.A_PermittedNumbers_Search
GO

Create procedure dbo.A_PermittedNumbers_Search
	@number nvarchar(50),
	@numberstarts nvarchar(50) = ''
as
Begin
	Select id, number
	From A_PermittedNumbers
	Where ( number like @number ) 
		or (( @numberstarts != '' ) and ( number like @numberstarts + '%' ))
End
GO


Insert into dbo.A_PermittedNumbers ( number ) Values ( '7xxxxxxxxxx' )
Insert into dbo.A_PermittedNumbers ( number ) Values ( '8xxxxxxxxxx' )
Insert into dbo.A_PermittedNumbers ( number ) Values ( 'xxxxxxxxxxxx' )
Insert into dbo.A_PermittedNumbers ( number ) Values ( 'xxxxxxxxxxx' )
Insert into dbo.A_PermittedNumbers ( number ) Values ( 'xxxxxxxxxx' )
Insert into dbo.A_PermittedNumbers ( number ) Values ( 'xxxxxxx' )
Insert into dbo.A_PermittedNumbers ( number ) Values ( 'xxxxxx' )

GO