if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_CallCenter_Info_GetOperator' ))
	Drop procedure dbo.W_CallCenter_Info_GetOperator
GO

Create procedure [dbo].[W_CallCenter_Info_GetOperator]
	@operator uniqueidentifier,							-- id 
	@getdate datetime = null							--  
as
begin

declare @StatusCurrent int											
declare @StartTimeCurrent datetime
declare @TimeReady datetime								
declare @TimeReadyLeftOrOvertime datetime
declare @TypeTRLOO int
declare @TimeRest datetime
declare @TimeRestLast datetime
declare @TimeTalk datetime
declare @TalkPrc float
declare @CallsTotal int
declare @CallsSuccess int
declare @TimeEnd datetime
declare @TimeNow datetime


declare	@table table
(
IdOperator uniqueidentifier,
StatusCurrent int,												
StartTimeCurrent datetime,
TimeReady datetime,										
TimeReadyLeftOrOvertime datetime,
TypeTRLOO int,
TimeRest datetime,
TimeRestLast datetime,
TimeTalk datetime,
TalkPrc float,
CallsTotal int,
CallsSuccess int,
TimeEnd datetime,
TimeNow datetime
)

insert into @table
select	@operator, null, null, null, null, null, null, null, null, null, null, null, null, getdate()


SET DATEFIRST 1
---------------
if (@getdate is null) set @getdate = getdate()
declare	@maxtime datetime
	set @maxtime = '1900-01-01 01:15:00.000'
declare	@mintime datetime
	set @mintime = '1900-01-01 00:10:00.000'
declare @workdaysec float
	set @workdaysec = 0
declare @sec float
	set @sec = 0
-------------------------
declare @temposh table (OperatorId uniqueidentifier, State int, TimeEnter datetime, TimeLeave datetime, LengthSec float)
declare @temp table (i int identity(1,1), IdOperator uniqueidentifier, State int, DateTimeStart datetime, DateTimeStop datetime, LenTimeSec float)
declare @tempwd table (IdOperator uniqueidentifier, State int, DateTimeStart datetime, DateTimeStop datetime, LenTimeSec float, DWDateTimeStart int, DWDateTimeStop int)
declare @tempott table (IdOperator uniqueidentifier, DayOfWeek int, StartTime datetime, FinishTime datetime, WorkDaySec float)

declare	@td table (i1 int, i2 int)

insert into @temposh														--   24 
select	OperatorId,
		State,
		TimeEnter,
		TimeLeave,
		LengthSec
from	[Oktell].[dbo].[A_CallCenter_UserStateHistory]
where	OperatorId = @operator
		and (TimeEnter between dateadd(day, -1, @getdate) and @getdate
		or TimeLeave between dateadd(day, -1, @getdate) and @getdate)

--select * from @temposh

insert into @temp															--   24 
select	IdOperator,
		State,
		DateTimeStart,
		DateTimeStop,
		LenTime
from	[Oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
where	IdOperator = @operator
		and (DateTimeStart between dateadd(day, -1, @getdate) and @getdate
		and DateTimeStop between dateadd(day, -1, @getdate) and @getdate)

--select * from @temp order by DateTimeStart

--select * from @table

if	(not exists	(
						select	*
						from	@temposh
						where	OperatorId = @operator
								and TimeLeave is null
				))

	begin																	--  offline
		select	@StatusCurrent = 0
		select	@StartTimeCurrent = '1900-01-01 00:00:00.000'
		
		update @table set StatusCurrent = @StatusCurrent
		update @table set StartTimeCurrent = @StartTimeCurrent
		
		--select * from @table
	end

else
	begin																	--  online
		
		
					--   "F5"
					
					declare @temposhi table (i int identity(1,1), OperatorId uniqueidentifier, State int, TimeEnter datetime, TimeLeave datetime, LengthSec float)
					declare @temposhi2 table (i int identity(1,1), OperatorId uniqueidentifier, State int, TimeEnter datetime, TimeLeave datetime, LengthSec float)
					declare @temposhi3 table (i int identity(1,1), OperatorId uniqueidentifier, State int, TimeEnter datetime, TimeLeave datetime, LengthSec float)
					declare @temposhi3_1 table (i int identity(1,1), OperatorId uniqueidentifier, State int, TimeEnter datetime, TimeLeave datetime, LengthSec float)

					declare @temposhi4 table (OperatorId uniqueidentifier, State int, TimeEnter datetime, TimeLeave datetime, LengthSec float)
		
		
		
		
					insert into @temposhi
					select	tosh.OperatorId,
							a.State,
							a.TimeEnter,
							tosh.TimeLeave,
							tosh.LengthSec
					from
					(
						select TimeEnter, max(State) State
						from	@temposh
						group by TimeEnter
					) a left join @temposh tosh
					on a.TimeEnter = tosh.TimeEnter and a.State = tosh.State
					order by 3



					--select * from @temposhi
					
					
					
					
					delete from @temposhi
							where	i between 1 and
							(
								select	max(a.i)
								from
								(
									select	t_.i i, cast(t__.TimeEnter - t_.TimeLeave as float) * 86400 LenTime
									from	@temposhi t_, @temposhi t__
									where	t_.i = t__.i - 1
								) a
								where	a.LenTime > cast(@maxtime as float) * 86400
							)


					--select * from @temposhi

					insert into @temposhi2
					select OperatorId, State, TimeEnter, TimeLeave,LengthSec from @temposhi
					--select * from @temposhi2



							delete from @temposhi2
							where	i in
							(
									select	t_.i i--, cast(t__.TimeEnter - t_.TimeLeave as float) * 86400 LenTime
									from	@temposhi2 t_, @temposhi2 t__
									where	t_.i = t__.i - 1 and t_.State = t__.State and datediff(second, t_.TimeLeave, t__.TimeEnter) < 10
							)

					--select * from @temposhi2

									insert into @temposhi2
									select	t_.OperatorId,
											t_.State,
											t_.TimeEnter,
											t_.TimeLeave,
											t_.LengthSec
									from	@temposhi t_, @temposhi t__
									where	t_.i - 1 = t__.i and t_.State != t__.State --and datediff(second, t_.TimeLeave, t__.TimeEnter) < 10

					insert into @temposhi3
					select distinct OperatorId, State, TimeEnter, TimeLeave, LengthSec from @temposhi2 order by TimeEnter

					insert into @temposhi3_1
					select OperatorId, State, TimeEnter, TimeLeave, LengthSec from @temposhi3 order by TimeEnter

					--select * from @temposhi3_1




					insert into @temposhi4
					select	t_.OperatorId, t_.State, t_.TimeEnter, t__.TimeLeave, cast(t__.TimeLeave - t_.TimeEnter as float) * 86400 LenTime
					from	@temposhi3_1 t_, @temposhi3_1 t__
					where	t_.i = t__.i - 1 and t_.State = t__.State


					--select * from @temposhi4


					delete from @temposhi3_1
					where	i in
					(
						select	t_.i
						from	@temposhi3 t_, @temposhi3 t__
						where	t_.i = t__.i - 1 and t_.State = t__.State
						union all
						select	t__.i
						from	@temposhi3 t_, @temposhi3 t__
						where	t_.i = t__.i - 1 and t_.State = t__.State
					)

					--select * from @temposhi3_1

					insert into @temposhi4
					select OperatorId, State, TimeEnter, TimeLeave, LengthSec from @temposhi3_1

					delete from @temposh where OperatorId = @operator

					insert into @temposh
					select * from @temposhi4 order by TimeEnter




					--select * from @temposh



					--  F5 
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		select	@StatusCurrent = max
									(case
										when State in (1,2) then 1
										when State = 3 then 2
									end)
		from
		(
			select	*
			from	@temposh
			where	TimeEnter =
			(
				select	max(TimeEnter)
				from
				(
				select	OperatorId,--@StatusCurrent = 
						--case
						--	when State in (1,2) then 1
						--	when State = 3 then 2
						--end
						State,
						TimeEnter,
						TimeLeave,
						LengthSec				
				from	@temposh
				where	TimeLeave is null
				) m1
			)
		) m2
		
		update @table set StatusCurrent = @StatusCurrent
		
				--  ,    
		delete from @temp
		where	i between 1 and
		(
			select	max(a.i)
			from
			(
				select	t_.i i, cast(t__.DateTimeStart - t_.DateTimeStop as float) * 86400 LenTime
				from	@temp t_, @temp t__
				where	t_.i = t__.i - 1
			) a
			where	a.LenTime > cast(@maxtime as float) * 86400
		)

		--select * from @temp order by DateTimeStart



/*
		--   ,      
		insert into @temp
		select	b.IdOperator, b.State, b.DateTimeStart, b.DateTimeStop2, b.LenTimeSecS
		from
		(
			select	t_.*,
					t_.LenTimeSec + t__.LenTimeSec LenTimeSecS,
					t__.DateTimeStop DateTimeStop2,
					cast(t__.DateTimeStart - t_.DateTimeStop as float ) * 86400 LenTime
			from	@temp t_, @temp t__
			where	t_.i = t__.i - 1
					and t_.State = t__.State
		) b
		where	b.LenTime < cast(@mintime as float) * 86400

		--  ,      
		insert into @td
		select	c.i,
				c.i2
		from
		(
			select	t_.*,
					t__.i i2,
					cast(t__.DateTimeStart - t_.DateTimeStop as float ) * 86400 LenTime
			from	@temp t_, @temp t__
			where	t_.i = t__.i - 1
					and t_.State = t__.State
		) c
		where	c.LenTime < cast(@mintime as float) * 86400

		--  ,      
		delete from @temp
		where	i in
		(
			select	i1
			from	@td
			union all
			select	i2
			from	@td
		)

		--select * from @temp order by DateTimeStart
		
		
		
*/		
		insert into @temp
		select	IdOperator = OperatorId,
				State =
				(case
					when State in (1,2) then 10
					when State = 3 then 9
				end),
				DateTimeStop = (select max(DateTimeStop) from @temp),
				DateTimeStop = @getdate,
				LenTimeSec = (cast(@getdate - (select max(DateTimeStop) from @temp) as float ) * 86400)
		from	@temposh
		where	State =
		(
			select	max(State)
			from	@temposh
			where	TimeLeave is null
		)
		and TimeLeave is null
		
		--select * from @temp order by DateTimeStart
		/*		
		select	@StartTimeCurrent = dateadd(second, LenTimeSec, getdate()) - getdate()
		from	@temp
		where	DateTimeStop =
		(select max(DateTimeStop) from @temp)
		*/
		select	@StartTimeCurrent = getdate() - TimeEnter
		from
		(
			select	*
			from	@temposh
			where	TimeEnter =
			(
				select	max(TimeEnter)
				from
				(
				select	OperatorId,--@StatusCurrent = 
						--case
						--	when State in (1,2) then 1
						--	when State = 3 then 2
						--end
						State,
						TimeEnter,
						TimeLeave,
						LengthSec				
				from	@temposh
				where	TimeLeave is null
				) m1
			)
		) m3
		where	State =
		(
		select	max(State)
		from
		(
			select	*
			from	@temposh
			where	TimeEnter =
			(
				select	max(TimeEnter)
				from
				(
				select	OperatorId,--@StatusCurrent = 
						--case
						--	when State in (1,2) then 1
						--	when State = 3 then 2
						--end
						State,
						TimeEnter,
						TimeLeave,
						LengthSec				
				from	@temposh
				where	TimeLeave is null
				) m1
			)
		) m2
		)

		/*
		select	@StartTimeCurrent = getdate() - TimeEnter
		from	@temposh
		where	TimeEnter =
		(
			select	max(TimeEnter)
			from	@temposh
		)
		and	State =
		(
			select	max(State)
			from	@temposh
		)
		and TimeLeave is null
		*/
		update @table set StartTimeCurrent = @StartTimeCurrent

		select	@TimeReady = dateadd(second, sum(LenTimeSec), getdate()) - getdate()
		from	@temp
		--where	State in (1,2,3,4,5,6,7,8,9,10)
		
		update @table set TimeReady = @TimeReady
		
		
		
		if	(not exists	(
								select	*
								from	[Oktell_settings].[dbo].[A_CallCenter_OperatorTimeTable]
								where	IdOperator = @operator
						))

			begin
				select @TimeReadyLeftOrOvertime = '1900-01-01 00:00:00.000'
				update @table set TimeReadyLeftOrOvertime = @TimeReadyLeftOrOvertime
			end

		else

			begin
				insert into @tempwd
				select	IdOperator, State, DateTimeStart, DateTimeStop, LenTimeSec, datepart(dw, DateTimeStart), datepart(dw, DateTimeStop)
				from	@temp
				--select * from @tempwd
				
				insert into @tempott
				select	*
				from
				(
					select	IdOperator,
					case
						when DayOfWeek = 0 then 7 else DayOfWeek
					end
					DayOfWeek,
					StartTime,
					FinishTime,
					cast(FinishTime-StartTime as float) * 86400 WorkDaySec
					from	[Oktell_settings].[dbo].[A_CallCenter_OperatorTimeTable]
					where	TableType = 1
							and IdOperator = @operator
				) dw
				where dw.DayOfWeek in
				(
					select top 1 DWDateTimeStart from @tempwd
				)
				--select * from @tempott
				
				
				if	(not exists	(
									select	*
									from	@tempott
									where	FinishTime = '2008-01-01 23:59:59.000'
					))
						begin
							select @workdaysec = WorkDaySec from @tempott
							--select @workdaysec
							
							--      
							select @sec = @workdaysec -
							(
							select sum(ss.LenTimeSec)
							from
							(
							select s.IdOperator, s.State, s.DateTimeStart, s.DateTimeStop, cast(s.DateTimeStop - s.DateTimeStart as float) * 86400 LenTimeSec
							from
							(
							select IdOperator, State, case when DateTimeStart < (select StartTime from @tempott) then (select StartTime from @tempott) else DateTimeStart end DateTimeStart, DateTimeStop  from @tempwd
							) s
							) ss
							--where ss.State in (1,2,3,4,5,6,7,8,10)
							group by ss.IdOperator
							)
							select @TypeTRLOO = 
												case 
													when @sec >= 0 then  1
													when @sec < 0 then  -1
												end
							select @TimeReadyLeftOrOvertime = 
																case
																	when @sec >=0 then dateadd(second, @sec, getdate()) - getdate()
																	when @sec < 0 then dateadd(second, @sec-@sec-@sec, getdate()) - getdate()
																end
							
							select @TimeEnd =
							(
								select	cast(floor(cast(getdate() as float)) as datetime) + (FinishTime - cast(floor(cast(FinishTime as float)) as datetime))  from @tempott
							)
							
							update @table set TypeTRLOO = @TypeTRLOO
							update @table set TimeReadyLeftOrOvertime = @TimeReadyLeftOrOvertime
							update @table set TimeEnd = @TimeEnd
							
						end

				else
				
						begin
							--select ''
							
							
							if ((select DayOfWeek from @tempott) = 7)
							begin
									
									
									
									select	@TimeEnd = dateadd(day, 1, cast(floor(cast(getdate() as float)) as datetime) + (FinishTime - cast(floor(cast(FinishTime as float)) as datetime)))
									from
									(
									select	IdOperator,
									case
										when DayOfWeek = 0 then 7 else DayOfWeek
									end
									DayOfWeek,
									StartTime,
									FinishTime,
									cast(FinishTime-StartTime as float) * 86400 WorkDaySec
									from	[Oktell_settings].[dbo].[A_CallCenter_OperatorTimeTable]
									where	TableType = 1
											and IdOperator = (select IdOperator from @tempott)
											and DayOfWeek between (select DayOfWeek from @tempott) and (select DayOfWeek + 1 from @tempott)
									) e
									where StartTime = '2008-01-01 00:00:00.000'
									
									if (@TimeEnd is null) set @TimeEnd =
																			(
																				select	cast(floor(cast(getdate() as float)) as datetime) + (FinishTime - cast(floor(cast(FinishTime as float)) as datetime))  from @tempott
																			)
																			
																			
									
									select @workdaysec = sum(e.WorkDaySec)
									from
									(
									select	IdOperator,
									case
										when DayOfWeek = 0 then 7 else DayOfWeek
									end
									DayOfWeek,
									StartTime,
									FinishTime,
									cast(FinishTime-StartTime as float) * 86400 WorkDaySec
									from	[Oktell_settings].[dbo].[A_CallCenter_OperatorTimeTable]
									where	TableType = 1
											and IdOperator = (select IdOperator from @tempott)
											and DayOfWeek in (7, 1)
									) e
									where StartTime = '2008-01-01 00:00:00.000' or FinishTime = '2008-01-01 23:59:59.000'
									--select @workdaysec
									
									
									--   ...
							select @sec = @workdaysec -
							(
							select sum(ss.LenTimeSec)
							from
							(
							select s.IdOperator, s.State, s.DateTimeStart, s.DateTimeStop, cast(s.DateTimeStop - s.DateTimeStart as float) * 86400 LenTimeSec
							from
							(
							select IdOperator, State, case when DateTimeStart < (select StartTime from @tempott) then (select StartTime from @tempott) else DateTimeStart end DateTimeStart, DateTimeStop  from @tempwd
							) s
							) ss
							--where ss.State in (1,2,3,4,5,6,7,8,10)
							group by ss.IdOperator
							)
							select @TypeTRLOO = 
												case 
													when @sec >= 0 then  1
													when @sec < 0 then  -1
												end
							select @TimeReadyLeftOrOvertime = 
																case
																	when @sec >=0 then dateadd(second, @sec, getdate()) - getdate()
																	when @sec < 0 then dateadd(second, @sec-@sec-@sec, getdate()) - getdate()
																end
							
							update @table set TypeTRLOO = @TypeTRLOO
							update @table set TimeReadyLeftOrOvertime = @TimeReadyLeftOrOvertime
							update @table set TimeEnd = @TimeEnd
							
							end
							else
							begin
									
									
									select	@TimeEnd = dateadd(day, 1, cast(floor(cast(getdate() as float)) as datetime) + (FinishTime - cast(floor(cast(FinishTime as float)) as datetime)))
									from
									(
									select	IdOperator,
									case
										when DayOfWeek = 0 then 7 else DayOfWeek
									end
									DayOfWeek,
									StartTime,
									FinishTime,
									cast(FinishTime-StartTime as float) * 86400 WorkDaySec
									from	[Oktell_settings].[dbo].[A_CallCenter_OperatorTimeTable]
									where	TableType = 1
											and IdOperator = (select IdOperator from @tempott)
											and DayOfWeek between (select DayOfWeek from @tempott) and (select DayOfWeek + 1 from @tempott)
									) e
									where StartTime = '2008-01-01 00:00:00.000'
									
									if (@TimeEnd is null) set @TimeEnd =
																			(
																				select	cast(floor(cast(getdate() as float)) as datetime) + (FinishTime - cast(floor(cast(FinishTime as float)) as datetime))  from @tempott
																			)
									
									
									
									select @workdaysec = sum(e.WorkDaySec)
									from
									(
									select	IdOperator,
									case
										when DayOfWeek = 0 then 7 else DayOfWeek
									end
									DayOfWeek,
									StartTime,
									FinishTime,
									cast(FinishTime-StartTime as float) * 86400 WorkDaySec
									from	[Oktell_settings].[dbo].[A_CallCenter_OperatorTimeTable]
									where	TableType = 1
											and IdOperator = (select IdOperator from @tempott)
											and DayOfWeek between (select DayOfWeek from @tempott) and (select DayOfWeek + 1 from @tempott)
									) e
									where StartTime = '2008-01-01 00:00:00.000' or FinishTime = '2008-01-01 23:59:59.000'
									--select @workdaysec
									
									--   ...
							select @sec = @workdaysec -
							(
							select sum(ss.LenTimeSec)
							from
							(
							select s.IdOperator, s.State, s.DateTimeStart, s.DateTimeStop, cast(s.DateTimeStop - s.DateTimeStart as float) * 86400 LenTimeSec
							from
							(
							select IdOperator, State, case when DateTimeStart < (select StartTime from @tempott) then (select StartTime from @tempott) else DateTimeStart end DateTimeStart, DateTimeStop  from @tempwd
							) s
							) ss
							--where ss.State in (1,2,3,4,5,6,7,8,10)
							group by ss.IdOperator
							)
							select @TypeTRLOO = 
												case 
													when @sec >= 0 then  1
													when @sec < 0 then  -1
												end
							select @TimeReadyLeftOrOvertime = 
																case
																	when @sec >=0 then dateadd(second, @sec, getdate()) - getdate()
																	when @sec < 0 then dateadd(second, @sec-@sec-@sec, getdate()) - getdate()
																end
							
							update @table set TypeTRLOO = @TypeTRLOO
							update @table set TimeReadyLeftOrOvertime = @TimeReadyLeftOrOvertime
							update @table set TimeEnd = @TimeEnd
							
							end
							
							
							
							
							
						end
				
				--select min(DateTimeStart) from @tempwd
				
				
				
			end
		
		
		select	@TimeRest = isnull(dateadd(second, sum(LenTimeSec), getdate()) - getdate(), '1900-01-01 00:00:00.000')
		from	@temp
		where	State in (9)
		
		update @table set TimeRest = @TimeRest
		
		select	@TimeRestLast = isnull(max(DateTimeStop), '1900-01-01 00:00:00.000')
	    from	[Oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
	    where	IdOperator = @operator
				and State = 9
		
		update @table set TimeRestLast = @TimeRestLast

		select	@TimeTalk = dateadd(second, sum(LenTimeSec), getdate()) - getdate()
		from	@temp
		where	State in (6)
		
		update @table set TimeTalk = @TimeTalk
			
		select	@TalkPrc = round((select sum(LenTimeSec) from @temp where State in (6)) * 100 / (select sum(LenTimeSec) from @temp where State in (1,2,3,4,5,6,7,8,9,10)), 2)
		
		update @table set TalkPrc = @TalkPrc
		
		select @CallsTotal = count(*)
	    from (
		select IdOperator, IdChain
		from (
			select IdOperator, IdChain, CallResult
			from oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec with (index(idxCubeConnections_DateTimeStart))
			where	ec.IdOperator = @operator
					and DateTimeStart >= (select min(DateTimeStart) from @temp)
					and DateTimeStop <= (select max(DateTimeStop) from @temp)
					and IdChain is not null
					and IdChain != '00000000-0000-0000-0000-000000000000'
					--And CallResult = 5
			)a
		group by IdOperator, IdChain
		)b
	    group by IdOperator
	    
	    update @table set CallsTotal = @CallsTotal
	    
	    select @CallsSuccess = count(*)
	    from (
		select IdOperator, IdChain
		from (
			select IdOperator, IdChain, CallResult
			from oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec with (index(idxCubeConnections_DateTimeStart))
			where	ec.IdOperator = @operator
					and DateTimeStart >= (select min(DateTimeStart) from @temp)
					and DateTimeStop <= (select max(DateTimeStop) from @temp)
					and IdChain is not null
					and IdChain != '00000000-0000-0000-0000-000000000000'
					and CallResult = 5
			)c
		group by IdOperator, IdChain
		)d
	    group by IdOperator
	    
	    update @table set CallsSuccess = @CallsSuccess
	    
	    
	end
	
	select * from @table

end
GO

----------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_CallCenter_Info_GetOperatorTasks' ))
	Drop procedure dbo.W_CallCenter_Info_GetOperatorTasks
GO

Create procedure [dbo].[W_CallCenter_Info_GetOperatorTasks]
	@operator uniqueidentifier							-- id 

as
begin

	declare	@table table
	(
	IdOperator uniqueidentifier,
	TaskName nvarchar(500),
	TaskStatus int
	)

	insert into @table
	select	o.OperatorId,
			t.Name,
			t.Active
	from	[Oktell_settings].[dbo].[A_TaskManager_Operators] o
			inner join [Oktell_settings].[dbo].[A_TaskManager_Tasks] t
			on o.TaskId = t.Id
	where	o.OperatorId = @operator


	select * from @table

end
GO