
if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Stat_Connection_SetVoiceParams' ))
	Drop procedure dbo.A_Stat_Connection_SetVoiceParams
GO

Create procedure dbo.A_Stat_Connection_SetVoiceParams
	@dtstart datetime,
	@alinenum nvarchar(10),
	@blinenum nvarchar(10),
	@avms int,
	@bvms int
as
begin
	Declare @idconn uniqueidentifier, @lensec int, @anum nvarchar(10), @bnum nvarchar(10)

	Select @idconn = Id, 
		@lensec = Abs ( cast ( TimeStop - TimeAnswer as float ) * 86400 ), 
		@anum = ALineNum, 
		@bnum = BLineNum
	From dbo.A_Stat_Connections_1x1 sc
	Where TimeStart = @dtstart
		And (( ALineNum = @alinenum And BLineNum = @blinenum ) or 
		     ( ALineNum = @blinenum And BLineNum = @alinenum ))

	if ( @@rowcount = 0 )
	    return

	Declare @a int, @b int
	Select @a = case when ( @lensec > 0 ) then @avms / @lensec / 10 else 0 end,
		@b = case when ( @lensec > 0 ) then @bvms / @lensec / 10 else 0 end

	if ( @anum = @alinenum )
		Insert into dbo.A_Stat_Connections_VoicePerc ( idconn, lensec, avperc, bvperc )
		Values ( @idconn, @lensec, @a, @b )
	else
		Insert into dbo.A_Stat_Connections_VoicePerc ( idconn, lensec, avperc, bvperc )
		Values ( @idconn, @lensec, @b, @a )
	
end
GO
