if exists ( select * from sysobjects where id=object_id ( 'dbo.A_Stat_Service_FillTempByFilter' ))
	Drop procedure dbo.A_Stat_Service_FillTempByFilter
GO

Create Procedure [dbo].[A_Stat_Service_FillTempByFilter]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = NULL, --Task defined
	@fromcc bit = NULL,
	@operatorid uniqueidentifier = NULL, --Operator defined
	@innerprefix nvarchar(100) = NULL, --Internal Number defined
	@outnumber nvarchar(100) = NULL,  --Out Number defined
	@conntype int = -1,
	@showconference bit = 0,
	@showfailed bit = 0,
	@comment nvarchar ( 4000 ) = NULL,
	@idconn uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@idchain uniqueidentifier = '00000000-0000-0000-0000-000000000000'
as
begin

----------------------------------------------
-------   ----------------
----------------------------------------------

	Declare @filtercomment bit
	Set @filtercomment = case when ( @comment IS NULL or @comment like '' ) then 0 else 1 end

	Declare @tstartfloat float  
	Declare @tstopfloat float 
	Set @tstartfloat = Convert ( float, @tstart )  
	Set @tstopfloat  = Convert ( float, @tstop )  
	Set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )  
	Set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )  
	If ( @tstopfloat <= @tstartfloat )
	    Set @tstopfloat = @tstopfloat + 1

	Declare @lt float
	Set @lt = Convert ( float, @lentime ) - Floor ( Convert ( float, @lentime ) )

	Declare @idempty uniqueidentifier
	Set @idempty = '00000000-0000-0000-0000-000000000000'
	
	Declare @idconfuser uniqueidentifier
	Set @idconfuser = 'CF000000-0000-0000-0000-000000000000'

--------------
--------------
	Declare @intnumbers table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
		
	if ( @innerprefix is not null ) begin

		Declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )

		Insert Into @intnumbers
			Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
			From A_NumberPlan np
				Inner join A_NumberPlanAction na on na.NumId = np.Id
				Inner join A_Rules r on na.ExtraId = r.Id
				Inner join A_RuleRecords rr on rr.RuleId = r.Id

		Declare @cnt int
		Set @cnt = 0

		While ( @@rowcount > 0 ) and ( @cnt < 10 ) begin

			Set @cnt = @cnt + 1

			/*    @cnt - */
			Insert Into @temp
				Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
				From @intnumbers t
					Inner join @intnumbers t1 on t.Reactid = t1.nId
				Where t.ReactId != t.Nid

			/*    */
			Delete From @intnumbers
				From @temp
			Where nid = id and reactid = oldrid

			/* */
			Insert Into @intnumbers ( nid, prefix, addrtype, reactid )
				Select id, prefix, addrtype, newrid 
				From @temp

			/* */
			Delete From @temp

		end --\MakePrefixTableAnyWay condition
	end

--##########################################################################################################
--##########################################################################################################
--##########################################################################################################
--##########################################################################################################
--##########################################################################################################
    ----------------------------------------------------
    ---  -------------------------------------
    ----------------------------------------------------

	--    
	if exists ( select * from tempdb..sysobjects where id=object_id ( 'tempdb..#A_Stat_Connections_1x1_tmp2' ))
		Drop table #A_Stat_Connections_1x1_tmp2
	Create table #A_Stat_Connections_1x1_tmp2 ( Id uniqueidentifier Primary Key )

	if exists ( select * from tempdb..sysobjects where id=object_id ( 'tempdb..#A_Stat_Connections_1x1_tmp' ))
		Drop table #A_Stat_Connections_1x1_tmp
	Create table #A_Stat_Connections_1x1_tmp ( Id uniqueidentifier PRIMARY KEY, AUSerId uniqueidentifier, BUSerId uniqueidentifier, ALineId uniqueidentifier, BLineId uniqueidentifier )

    -----------------------------------------------
    -------    ----------
    -----------------------------------------------

	if (( @idchain = '00000000-0000-0000-0000-000000000000' ) and ( @idconn = '00000000-0000-0000-0000-000000000000' )) begin

		-- Date & Time Intervals
		--        ,      
		--        ,       
		Insert into #A_Stat_Connections_1x1_tmp 
		Select Id, AUSerId , BUSerId , ALineId , BLineId 
		From A_Stat_Connections_1x1 sc --With ( TabLock )
		Where ( TimeStart >= @dstart ) and ( TimeStart < @dstop ) 
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )  
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) <= @tstopfloat ) 
			and ( Convert ( float, TimeStop ) - Convert ( float, TimeAnswer ) >= @lt )
			and (( FromCC is null ) or ( FromCC <= @fromcc ))
			and (@conntype = -1 or (@conntype = 1 and ConnectionType in (4,5)) or (@conntype = 2 and ConnectionType in (1,6,7)) or (@conntype = 3 and ConnectionType in (2,3,8)))

	end else if ( @idchain = '00000000-0000-0000-0000-000000000000' ) begin
		
		Insert into #A_Stat_Connections_1x1_tmp 
		Select Id, AUSerId , BUSerId , ALineId , BLineId 
		From A_Stat_Connections_1x1 sc --With ( TabLock )
		Where ( Id = @idconn )
			and ( Convert ( float, TimeStop ) - Convert ( float, TimeAnswer ) >= @lt )
			and (( FromCC is null ) or ( FromCC <= @fromcc ))
			and (@conntype = -1 or (@conntype = 1 and ConnectionType in (4,5)) or (@conntype = 2 and ConnectionType in (1,6,7)) or (@conntype = 3 and ConnectionType in (2,3,8)))
	
	end else if ( @idconn = '00000000-0000-0000-0000-000000000000' ) begin
		
		Insert into #A_Stat_Connections_1x1_tmp 
		Select Id, AUSerId , BUSerId , ALineId , BLineId 
		From A_Stat_Connections_1x1 sc --With ( TabLock )
		Where ( IdChain = @idchain )			
			and ( Convert ( float, TimeStop ) - Convert ( float, TimeAnswer ) >= @lt )
			and (( FromCC is null ) or ( FromCC <= @fromcc ))
			and (@conntype = -1 or (@conntype = 1 and ConnectionType in (4,5)) or (@conntype = 2 and ConnectionType in (1,6,7)) or (@conntype = 3 and ConnectionType in (2,3,8)))
	
	end else begin

		Insert into #A_Stat_Connections_1x1_tmp 
		Select Id, AUSerId , BUSerId , ALineId , BLineId 
		From A_Stat_Connections_1x1 sc --With ( TabLock )
		Where ( IdChain = @idchain )
			and ( Id = @idconn )		
			and ( Convert ( float, TimeStop ) - Convert ( float, TimeAnswer ) >= @lt )
			and (( FromCC is null ) or ( FromCC <= @fromcc ))
			and (@conntype = -1 or (@conntype = 1 and ConnectionType in (4,5)) or (@conntype = 2 and ConnectionType in (1,6,7)) or (@conntype = 3 and ConnectionType in (2,3,8)))
	end

    --------------------------------------------
    -------     ----------
    --------------------------------------------

	Declare @commpermitted table ( Id uniqueidentifier PRIMARY KEY ) -- Id Connection

	------------------------------------
	--  
	------------------------------------

	Declare @upermitted table ( Id uniqueidentifier Primary Key )
	Insert into @upermitted
		Select UserB
		From A_UserControls auc
		Where UserA = @iduser

	If not exists ( Select UserB From A_UserControls Where ( UserA = @iduser ) and ( UserB = @iduser )) 
		Insert into @upermitted ( Id ) 
		Values ( @iduser )

	Insert into @commpermitted
		Select sc.ID --auc.UserB   	
		From @upermitted up
			Inner join #A_Stat_Connections_1x1_tmp sc on up.Id = sc.AUserId
	
	Insert into @commpermitted
		Select sc.ID --auc.UserB   	
		From @upermitted up
			Inner join #A_Stat_Connections_1x1_tmp sc on up.Id = sc.BUserId
		Where not exists ( Select id From @commpermitted Where Id = sc.ID)


	------------------------------------
	--  
	------------------------------------

	Declare @lpermitted table ( Id uniqueidentifier Primary Key )
	Insert into @lpermitted
    	    Select IdLine
    	    From A_UserControlLines
    	    Where ( UserA = @iduser )
          	and ( IdLine != '11111111-1111-1111-1111-111111111111' )

	Declare @canlistenext int       
	Select @canlistenext = Count ( * ) 
	From A_UserControlLines 
	Where ( UserA = @iduser ) 
		and ( IdLine = '11111111-1111-1111-1111-111111111111' )

	if ( @canlistenext > 0 ) begin
    		Insert into @lpermitted
	            Select Id 
        	    From A_ServerExtLines sel
	            Where not exists ( Select id From @lpermitted Where Id = sel.ID )

		Insert into @lpermitted ( Id ) 
		Values ( 'BF000000-0000-0000-0000-000000000000' )		  
	end
     
	Insert into @commpermitted
    	    Select distinct sc.ID            
    	    From @lpermitted l
	          Inner join #A_Stat_Connections_1x1_tmp sc on ( sc.ALineId = l.Id ) or ( sc.AUserId = l.Id )
    	    Where not exists ( Select id From @commpermitted Where Id = sc.ID )

	Insert into @commpermitted            
    	    Select distinct sc.ID            
    	    From @lpermitted l
          	Inner join #A_Stat_Connections_1x1_tmp sc on ( sc.BLineId = l.Id ) or ( sc.BUserId = l.Id )
    	    Where not exists ( Select id From @commpermitted Where Id = sc.ID)

	Delete 
	From #A_Stat_Connections_1x1_tmp 
	Where id not in ( Select Id from @commpermitted )


    ------------------------------------------
    -------    ----------------
    ------------------------------------------

	----------------------------------
	--  
	----------------------------------

	if ( @innerprefix is not null ) begin
		
		--Users
		Insert into #A_Stat_Connections_1x1_tmp2 
  		    Select Id
		    From #A_Stat_Connections_1x1_tmp sc
			Inner join @intnumbers t on sc.AUserID=t.reactid
		    Where ( addrtype = 0 ) 
			and ( prefix like @innerprefix )

		Insert into #A_Stat_Connections_1x1_tmp2 
		    Select Id
		    From #A_Stat_Connections_1x1_tmp sc
			Inner join @intnumbers t on sc.BUserID=t.reactid
		    Where ( addrtype = 0 ) 
			and ( prefix like @innerprefix )
			and not exists ( Select Id From #A_Stat_Connections_1x1_tmp2 Where id = sc.ID )

		--Lines
		Insert into #A_Stat_Connections_1x1_tmp2 
		    Select Id
		    From #A_Stat_Connections_1x1_tmp sc
			Inner join @intnumbers t on sc.ALineId=t.reactid
		    Where ( addrtype = 1 ) 
			and ( prefix like @innerprefix )
			and not exists ( Select Id From #A_Stat_Connections_1x1_tmp2 Where Id = sc.ID )

		Insert into #A_Stat_Connections_1x1_tmp2 
		    Select Id
		    From #A_Stat_Connections_1x1_tmp sc
			Inner join @intnumbers t on sc.BLineId=t.reactid
		    Where ( addrtype = 1 ) 
			and ( prefix like @innerprefix )
			and not exists ( Select Id From #A_Stat_Connections_1x1_tmp2 Where Id = sc.ID )
		
		Delete #A_Stat_Connections_1x1_tmp 
		Where Id not in ( Select Id From #A_Stat_Connections_1x1_tmp2 )

		Truncate table #A_Stat_Connections_1x1_tmp2
		
	end 

	---------------------------------------
	--  
	---------------------------------------

	if ( @OutNumber is not null ) begin

		Insert into #A_Stat_Connections_1x1_tmp2 
		    Select Id
		    From A_Stat_Connections_1x1 sc
		    Where ( TimeStart >= @dstart ) and ( TimeStart < @dstop ) 
			and ( AOutNumber like '%'+@OutNumber+'%' )

		Insert into #A_Stat_Connections_1x1_tmp2 
		    Select Id
		    From A_Stat_Connections_1x1 sc
		    Where ( TimeStart >= @dstart ) and ( TimeStart < @dstop ) 
			and ( BOutNumber like '%'+@OutNumber+'%' )
			and not exists ( Select id From #A_Stat_Connections_1x1_tmp2 Where id = sc.ID )

		Delete 
		From #A_Stat_Connections_1x1_tmp 
		Where id not in ( Select Id From #A_Stat_Connections_1x1_tmp2 )

		Truncate table #A_Stat_Connections_1x1_tmp2

	end

    ----------------------------------------------------
    -------    ---------------------
    ----------------------------------------------------

	if ( @operatorid is not null ) begin

		Insert into #A_Stat_Connections_1x1_tmp2 
		    Select Id
		    From #A_Stat_Connections_1x1_tmp sc
		    Where AUserId = @operatorid

		Insert into #A_Stat_Connections_1x1_tmp2 
		select Id 
		from #A_Stat_Connections_1x1_tmp sc
		where BUserId = @operatorid
			and not exists ( Select id From #A_Stat_Connections_1x1_tmp2 where id = sc.ID )

		Delete 
		From #A_Stat_Connections_1x1_tmp 
		Where id not in ( Select Id From #A_Stat_Connections_1x1_tmp2 )
		
		Truncate table #A_Stat_Connections_1x1_tmp2
	end

    ------------------------------------------------
    --    ( ) 
    ------------------------------------------------

	if ( @filtercomment > 0 ) begin

		Delete 
		From #A_Stat_Connections_1x1_tmp
		Where id not in ( Select Id From A_Stat_Comments Where Comment like '%' + @comment + '%' )
	end


--##########################################################################################################
--##########################################################################################################
--##########################################################################################################
--##########################################################################################################
--##########################################################################################################
    ------------------------------------------------
    -------   --------------------
    ------------------------------------------------

    if (( @showfailed = 1 ) and ( @lt = 0 )) begin

	--    
	if exists ( select * from tempdb..sysobjects where id=object_id ( 'tempdb..#A_Stat_Failed_tmp' ))
		Drop table #A_Stat_Failed_tmp
	Create table #A_Stat_Failed_tmp ( Id uniqueidentifier PRIMARY KEY, AUSerId uniqueidentifier, ALineId uniqueidentifier )

	if exists ( select * from tempdb..sysobjects where id=object_id ( 'tempdb..#A_Stat_Failed_tmp2' ))
		Drop table #A_Stat_Failed_tmp2
	Create table #A_Stat_Failed_tmp2 ( Id uniqueidentifier PRIMARY KEY )

    ------------------------------------------------
    -------     ----------
    ------------------------------------------------
	
	if (( @idchain = '00000000-0000-0000-0000-000000000000' ) and ( @idconn = '00000000-0000-0000-0000-000000000000' )) begin

		--        ,      
		--        ,       
		Insert into #A_Stat_Failed_tmp
			Select sc.Id, sc.AUserId, sc.ALineId
			From A_Stat_FailedCalls sc
			Where ( TimeStart >= @dstart ) and ( TimeStart < @dstop ) 
				and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )  
				and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) <= @tstopfloat ) 
				and ( Convert ( float, TimeStart ) - Convert ( float, TimeStart ) >= @lt )
	end

    --------------------------------------------
    -------     ----------
    --------------------------------------------

	------------------------------------
	--  
	------------------------------------

	Insert into @commpermitted
	    Select sc.ID
	    From @upermitted up
		Inner join #A_Stat_Failed_tmp sc on up.Id = sc.AUserId

	------------------------------------
	--  
	------------------------------------

	Insert into @commpermitted
    	    Select distinct sc.ID            
    	    From @lpermitted l
	          Inner join #A_Stat_Failed_tmp sc on ( sc.ALineId = l.Id ) or ( sc.AUserId = l.Id )
    	    Where not exists ( Select id From @commpermitted Where Id = sc.ID )

	------------------------------------
	--    
	------------------------------------

	Delete 
	From #A_Stat_Failed_tmp 
	Where id not in ( Select Id from @commpermitted )

    ------------------------------------------------
    --------    ---------------------
    ------------------------------------------------

	------------------------------------
	--  
	------------------------------------

	if ( @innerprefix is not null ) begin

		--Users
		Insert into #A_Stat_Failed_tmp2 
  		    Select Id
		    From #A_Stat_Failed_tmp sc
			Inner join @intnumbers t on sc.AUserID = t.reactid
		    Where ( addrtype = 0 ) 
			and ( prefix like @innerprefix )

		--Lines
		Insert into #A_Stat_Failed_tmp2 
		    Select Id
		    From #A_Stat_Failed_tmp sc
			Inner join @intnumbers t on sc.ALineId = t.reactid
		    Where ( addrtype = 1 ) 
			and ( prefix like @innerprefix )
			and not exists ( Select Id From #A_Stat_Failed_tmp2 Where Id = sc.ID )

		
		Delete #A_Stat_Failed_tmp 
		Where Id not in ( Select Id From #A_Stat_Failed_tmp2 )

		Truncate table #A_Stat_Failed_tmp2
	end

	---------------------------------------
	--  
	---------------------------------------

	if ( @OutNumber is not null ) begin

		Insert into #A_Stat_Failed_tmp2 
		    Select Id
		    From A_Stat_FailedCalls sc
		    Where ( TimeStart >= @dstart ) and ( TimeStart < @dstop ) 
			and ( AOutNumber like '%'+@OutNumber+'%' )

		Insert into #A_Stat_Failed_tmp2 
		    Select Id
		    From A_Stat_FailedCalls sc
		    Where ( TimeStart >= @dstart ) and ( TimeStart < @dstop ) 
			and ( ANumberDialed like '%'+@OutNumber+'%' )
			and not exists ( Select id From #A_Stat_Failed_tmp2 Where id = sc.ID )

		Delete 
		From #A_Stat_Failed_tmp 
		Where id not in ( Select Id From #A_Stat_Failed_tmp2 )

		Truncate table #A_Stat_Failed_tmp2

	end

    ----------------------------------------------------
    -------    ---------------------
    ----------------------------------------------------

	if ( @operatorid is not null ) begin

		Insert into #A_Stat_Failed_tmp2 
		    Select Id
		    From #A_Stat_Failed_tmp sc
		    Where AUserId = @operatorid


		Delete 
		From #A_Stat_Failed_tmp 
		Where id not in ( Select Id From #A_Stat_Failed_tmp2 )
		
		Truncate table #A_Stat_Failed_tmp2
	end

    ------------------------------------------------
    --    ( ) 
    ------------------------------------------------

	if ( @filtercomment > 0 ) begin

		Delete 
		From #A_Stat_Failed_tmp
		Where id not in ( Select Id From A_Stat_Comments Where Comment like '%' + @comment + '%' )
	  end

    end


--##########################################################################################################
--##########################################################################################################
--##########################################################################################################
--##########################################################################################################
--##########################################################################################################
    ------------------------------------------------
    -------  ----------------------------
    ------------------------------------------------

    if ( @showconference = 1 ) begin

	--    
	if exists ( select * from tempdb..sysobjects where id=object_id ( 'tempdb..#A_Stat_Conference_tmp' ))
		Drop table #A_Stat_Conference_tmp
	Create table #A_Stat_Conference_tmp ( Id uniqueidentifier PRIMARY KEY, RecordAccess int, Director uniqueidentifier )

	if exists ( select * from tempdb..sysobjects where id=object_id ( 'tempdb..#A_Stat_Conference_tmp2' ))
		Drop table #A_Stat_Conference_tmp2
	Create table #A_Stat_Conference_tmp2 ( Id uniqueidentifier PRIMARY KEY )

    ------------------------------------------------
    -------    ----------
    ------------------------------------------------

	if (( @idchain = '00000000-0000-0000-0000-000000000000' ) and ( @idconn = '00000000-0000-0000-0000-000000000000' )) begin

		--        ,      
		--        ,       
		Insert into #A_Stat_Conference_tmp
			Select sc.Id, sc.RecordAccess, sc.Director 
			From A_Stat_Conference sc
			Where ( TimeStart >= @dstart ) and ( TimeStart < @dstop ) 
				and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )  
				and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) <= @tstopfloat ) 
				and ( Convert ( float, TimeStop ) - Convert ( float, TimeStart ) >= @lt )
				and (( @conntype = -1 ) or ( @conntype = 4 ))

	end else if ( @idchain = '00000000-0000-0000-0000-000000000000' ) begin

		Insert into #A_Stat_Conference_tmp
			Select sc.Id, sc.RecordAccess, sc.Director 
			From A_Stat_Conference sc
				Inner join A_Stat_Conference_Competitors scc on sc.Id = scc.IdConf
			Where ( scc.IdConn = @idconn )
				and ( Convert ( float, sc.TimeStop ) - Convert ( float, sc.TimeStart ) >= @lt )
				and (( @conntype = -1 ) or ( @conntype = 4 ))

	end else if ( @idconn = '00000000-0000-0000-0000-000000000000' ) begin	
	
		Insert into #A_Stat_Conference_tmp
			Select sc.Id, sc.RecordAccess, sc.Director 
			From A_Stat_Conference sc
				Inner join A_Stat_Conference_Competitors scc on sc.Id = scc.IdConf
			Where ( sc.Id = @idchain )
				and ( Convert ( float, sc.TimeStop ) - Convert ( float, sc.TimeStart ) >= @lt )
				and (( @conntype = -1 ) or ( @conntype = 4 ))
	end else begin

		Insert into #A_Stat_Conference_tmp
			Select sc.Id, sc.RecordAccess, sc.Director 
			From A_Stat_Conference sc
				Inner join A_Stat_Conference_Competitors scc on sc.Id = scc.IdConf
			Where ( sc.Id = @idchain )
				and ( scc.IdConn = @idconn )
				and ( Convert ( float, sc.TimeStop ) - Convert ( float, sc.TimeStart ) >= @lt )
				and (( @conntype = -1 ) or ( @conntype = 4 ))
	end


    --------------------------------------------------------
    -------  ----------------------------------------
    --------------------------------------------------------

	------------------------------------------------
	--    ( ) 
	------------------------------------------------

	if ( @filtercomment > 0 ) begin
		Delete 
		From #A_Stat_Conference_tmp
		Where id not in ( Select Id From A_Stat_Comments Where Comment like '%' + @comment + '%' )
	end

	------------------------------------------------
	--   
	------------------------------------------------

	Insert into #A_Stat_Conference_tmp2
		Select sc.Id From #A_Stat_Conference_tmp sc
			Inner join @upermitted up on sc.Director = up.Id
		Where sc.RecordAccess = 1 --  

	Insert into #A_Stat_Conference_tmp2
		Select sc.Id From #A_Stat_Conference_tmp sc			
			Inner join A_Stat_Conference_Competitors scc on sc.Id = scc.IdConf
			Inner join @upermitted up on scc.IdUser = up.Id
		Where sc.RecordAccess = 2 -- 
		Group By sc.Id

	Insert into #A_Stat_Conference_tmp2
		Select sc.Id From #A_Stat_Conference_tmp sc
			Inner join A_Stat_Conference_RecordAccessUsers scr on sc.Id = scr.IdConf
			Inner join @upermitted up on scr.IdUser = up.Id
		Where sc.RecordAccess = 3 --  
		Group By sc.Id

	if ( @canlistenext > 0 ) begin 

	    -- ,        , 
	    Insert into #A_Stat_Conference_tmp2
		Select sc.Id From #A_Stat_Conference_tmp sc
			Inner join A_Stat_Conference_Competitors scc on scc.IdConf = sc.Id
		Where scc.IdUser = 'BF000000-0000-0000-0000-000000000000'
			And not exists ( Select id from #A_Stat_Conference_tmp2 where id = sc.Id )
		Group By sc.Id
        end

	----------------------------------
	--  
	----------------------------------

	if exists ( select * from tempdb..sysobjects where id=object_id ( 'tempdb..#A_Stat_Conference_tmp3' ))
		Drop table #A_Stat_Conference_tmp3
	Create table #A_Stat_Conference_tmp3 ( IdItem uniqueidentifier PRIMARY KEY )

	if ( @innerprefix is not null ) begin

		Insert into #A_Stat_Conference_tmp3 ( iditem )
			Select ReactId
			From @intnumbers t
			Where ( prefix like @innerprefix )
				and ( addrtype in ( 0, 1 ))
	end

    end

--##########################################################################################################
--##########################################################################################################
--##########################################################################################################
--##########################################################################################################
--##########################################################################################################
-----------------------------------------------------------
-------   -----------------------------
-----------------------------------------------------------

	if exists ( select * from tempdb..sysobjects where id=object_id ( 'tempdb..#A_Stat_Result' ))
		Drop table #A_Stat_Result

	--------------------------------
	-- 
	--------------------------------
	Select sc.*, 
		0 as IsConf, @idempty as Director, sc.TimeStart as CTS, 
		case When ( c.Id is null ) then 0 else 1 end as HasComment
	Into #A_Stat_Result
	From A_Stat_Connections_1x1 sc
		Inner join #A_Stat_Connections_1x1_tmp sct on sc.Id=sct.Id
		Left join A_Stat_Comments c on sc.Id = c.Id

	--------------------------------
	--  
	--------------------------------

   	if (( @showfailed = 1 ) and ( @lt = 0 )) begin

	    Insert into #A_Stat_Result ( Id, IdChain, IdPrev, IdNext,
					TimeStart, TimeAnswer, TimeStop,
					ReasonStart, ReasonStop, StopSide,
					ALineId, BLineId,
					AOutNumber, BOutNumber, 
					ALineNum, BLineNum,
					AUserId, BUserId,
					ANumberDialed, BNumberDialed,
					IsRecorded, ConnectionType,
					AStr, BStr,
					FromCC, IsBetweenUsers, IdRecDir,
					IsConf, Director, CTS, HasComment )

 	    	Select sc.Id, sc.IdChain, @idempty as IdPrev, @idempty as IdNext, 
			sc.TimeStart, sc.TimeStop as TimeAnswer, sc.TimeStop,
			sc.ReasonStart, sc.ReasonFailed, 0 as StopSide, 
			sc.ALineId, sc.BLineId,
			sc.AOutNumber, sc.ANumberDialed as BOutNumber,
			sc.ALineNum, sc.BLineNum,
			sc.AUserId, @idempty as BUserId,
			sc.ANumberDialed, '' as BNumberDialed,
			0 as IsRecorded, 
			21 as ConnectionType,
			sc.AStr, sc.BStr, 
			sc.FromCC,
			case when ( sc.BLineId is NULL or sc.BLineId = @idempty ) then 1 else 0 end as IsBetweenUsers,
			0 as IdRecDir,
			0 as IsConf, @idempty as Director, sc.TimeStart as CTS,
			case When ( c.Id is null ) then 0 else 1 end as HasComment
 
		From A_Stat_FailedCalls sc
			Inner join #A_Stat_Failed_tmp sct on sc.Id = sct.Id
			Left join A_Stat_Comments c on sc.Id = c.Id
	end

	------------------------------------------------
	----  --------------------------------
	------------------------------------------------

    	if ( @showconference = 1 ) begin

	    Insert into #A_Stat_Result ( Id, IdChain, IdPrev, IdNext,
					TimeStart, TimeAnswer, TimeStop,
					ReasonStart, ReasonStop, StopSide,
					ALineId, BLineId,
					AOutNumber, BOutNumber, 
					ALineNum, BLineNum,
					AUserId, BUserId,
					ANumberDialed, BNumberDialed,
					IsRecorded, ConnectionType,
					AStr, BStr,
					FromCC, IsBetweenUsers, IdRecDir,
					IsConf, Director, CTS, HasComment )

   	    	--     ,        
	    	--        
	    	Select IdConn, sc.Id as IdChain, @idempty as IdPrev, @idempty as IdNext, 
			scc.TimeStart, scc.TimeStart as TimeAnswer, scc.TimeStop, 
			ReasonStart, ReasonStop, 0 as StopSide, 
			IdLine as ALineId, IdConf as BLineId, 
			OutNumber as AOutNumber, '' as BOutNumber, 
			LineNum as ALineNum, SubString ( cast ( Room as nvarchar ( 10 ) ), 1, 10 ) as BLineNum, 
			IdUser as AUserId, @idconfuser as BUserId, 
			'' as ANumberDialed, '' as BNumberDialed, 
			IsRecorded, case when ( sc.Type = 1 ) then 11/**/ else 10/**/ end as ConnectionType, 
			StrName as AStr, SubString ( case when ( Name != '' ) then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end, 1, 200 ) as BStr, 
			0 as FromCC, 1 as IsBetweenUsers, IdRecDir, 
			1 as IsConf, sc.Director, sc.TimeStart as CTS,
			case When ( c.Id is null ) then 0 else 1 end as HasComment

		From A_Stat_Conference_Competitors scc
			Inner join A_Stat_Conference sc on sc.Id = scc.IdConf
			Inner join #A_Stat_Conference_tmp2 sct on sc.Id = sct.Id --  
			Left join A_Stat_Comments c on sc.Id = c.Id
			--Inner join @upermitted up on up.Id = scc.IdUser --             

		Where ((( scc.TimeStart <= @dstart ) and ( scc.TimeStop > @dstart ))
			or (( scc.TimeStart < @dstop ) and ( scc.TimeStop >= @dstop ))
			or (( scc.TimeStart <= @dstart ) and ( scc.TimeStop > @dstart ))
			or (( scc.TimeStart >= @dstart ) and ( scc.TimeStop <= @dstop )))
			and ( Convert ( float, scc.TimeStop ) - Convert ( float, scc.TimeStart ) >= @lt )
			and (( @operatorid is null ) or ( scc.IdUser = @operatorid ))
			and (( @OutNumber is null ) or ( scc.OutNumber = @OutNumber ))
			and (( @innerprefix is null ) 
				or ( scc.IdLine in (Select iditem from #A_Stat_Conference_tmp3)) 
				or ( scc.IdUser in (Select iditem from #A_Stat_Conference_tmp3 )))
    	end

	
    ------------------------------------------------
    ----   -------------------------
    ------------------------------------------------

	Select * 
	From #A_Stat_Result

end
GO
