If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ServerSipLines' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerSipLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'IsDynamicConfig' )
	Alter Table oktell_settings.dbo.A_ServerSipLines
	Add [IsDynamicConfig] bit default 0
GO

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ServerSipLines' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerSipLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'SipPass' )
	Alter Table oktell_settings.dbo.A_ServerSipLines
	Add [SipPass] nvarchar(100) default ''
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ServerSipLines]') and OBJECTPROPERTY(id, N'IsView') = 1)
	drop view [dbo].[A_ServerSipLines]
GO


Create VIEW dbo.A_ServerSipLines
As
	Select *
	FROM oktell_settings.dbo.A_ServerSipLines
GO


Update dbo.A_ServerSipLines
Set IsDynamicConfig = 0
Where IsDynamicConfig is NULL
GO


Update dbo.A_ServerSipLines
Set SipPass = ''
Where SipPass is NULL
GO


---------------------------------

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_DynamicConfig_Clear' ))
	Drop procedure dbo.A_DynamicConfig_Clear
GO

Create Procedure [dbo].[A_DynamicConfig_Clear] 
	@ext bit = 1,
	@int bit = 1
as
begin
	if ( @int = 1 ) begin

		Delete From A_ServerSipLines Where IsDynamicConfig = 1
	end

	if ( @ext = 1 ) begin
		
		Delete FROM A_ServerExtLines Where IsDynamicConfig = 1
		Delete FROM A_ServerGates Where IsDynamicConfig = 1
		Delete FROM A_ServerStreams Where IsDynamicConfig = 1
		Delete FROM A_CallRoutes Where IsDynamicConfig = 1	

		Delete From A_CallRoutes_Lines where not [idroute] in ( Select [ID] From A_CallRoutes )
	end
end
GO

---------------------------


if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Remove_Phone' ))
	Drop procedure dbo.A_DynamicConfig_Remove_Phone
GO

Create procedure dbo.A_DynamicConfig_Remove_Phone
 	@phoneid uniqueidentifier
as
Begin
	Delete From A_ServerSipLines
	Where Id = @phoneid
End
GO


---------------------------


if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Modify_Phone' ))
	Drop procedure dbo.A_DynamicConfig_Modify_Phone
GO

Create procedure dbo.A_DynamicConfig_Modify_Phone
	@phoneid uniqueidentifier,
	@parentgroupid uniqueidentifier = null,
	@defuserid uniqueidentifier = null,
	@websockuserid uniqueidentifier = null,
	@account nvarchar(100) = null,
	@sippass nvarchar(100) = null,
	@linecode nvarchar(200) = null,
	@citystraight bit = null,
	@busymode int = null,
	@translit int = null
as
Begin
	Update A_ServerSipLines
	Set 	
		ParentGroupId = IsNull ( @parentgroupid, ParentGroupId ),
		DefaultUserId = IsNull ( @defuserid, DefaultUserId ),
		WebSockUserId = IsNull ( @websockuserid, WebSockUserId ),
		Address = IsNull ( @account, Address ),
		SipPass = IsNull ( @sippass, SipPass ),
		LineCode = IsNull ( @linecode, LineCode ),
		BusyMode = IsNull ( @busymode, BusyMode ),
		CityStraight = IsNull ( @citystraight, CityStraight ),
		Translit = IsNull ( @translit, Translit )
	Where Id = @phoneid

	Declare @empty uniqueidentifier
	Set @empty = '00000000-0000-0000-0000-000000000000'

	if (( @websockuserid is not null ) and ( @websockuserid != @empty ))
		Update A_ServerSipLines 
		Set WebSockUserId = @empty
		Where WebSockUserId != @empty
			And Id != @phoneid 
			And WebSockUserId = @websockuserid 

	if (( @defuserid is not null ) and ( @defuserid != @empty ))
		Update A_ServerSipLines 
		Set DefaultUserId = @empty
		Where DefaultUserId != @empty
			And Id != @phoneid 
			And DefaultUserId = @defuserid 
End
GO

----------------------------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Add_Phone' ))
	Drop procedure dbo.A_DynamicConfig_Add_Phone
GO

Create procedure dbo.A_DynamicConfig_Add_Phone
	@phoneid uniqueidentifier,
	@type int = 5,
	@caption nvarchar(200) = '',	
	@linenumstr nvarchar(20) = '',
	@parentgroupid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@defuserid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@websockuserid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@account nvarchar(100) = '',
	@sippass nvarchar(100) = '',
	@linecode nvarchar(200) = '',
	@citystraight bit = 0,
	@busymode int = 1,	
	@translit int = -1,
	@serverid uniqueidentifier = '00000000-0000-0000-0000-000000000000'
as
Begin
	Declare @srvid uniqueidentifier
	Set @srvid = @serverid
	if ( @srvid = '00000000-0000-0000-0000-000000000000' )
		Select @srvid = [Id] 
		From A_WorkPlaces 
		Where ( hasfastengine = 1 ) and ( ParentID = '00000000-0000-0000-0000-000000000000' )
		
	Insert into A_ServerSipLines ( Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, DefaultUserId, Address, SipPass, StreamId, BusyMode, LineCode, WebsockUserId, Translit, SystemNumStr, IsDynamicConfig )
	Values ( @phoneid, @type, @srvid, 0, 1, @caption, @citystraight, @parentgroupid, @defuserid, @account, @sippass, '00000000-0000-0000-0000-000000000000', @busymode, @linecode, @websockuserid, @translit, @linenumstr, 1)


	Declare @empty uniqueidentifier
	Set @empty = '00000000-0000-0000-0000-000000000000'

	if (( @websockuserid is not null ) and ( @websockuserid != @empty ))
		Update A_ServerSipLines 
		Set WebSockUserId = @empty
		Where WebSockUserId != @empty
			And Id != @phoneid 
			And WebSockUserId = @websockuserid 

	if (( @defuserid is not null ) and ( @defuserid != @empty ))
		Update A_ServerSipLines 
		Set DefaultUserId = @empty
		Where DefaultUserId != @empty
			And Id != @phoneid 
			And DefaultUserId = @defuserid 
End
GO

-----------------------------------------


if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Add_ExtLine' ))
	Drop procedure dbo.A_DynamicConfig_Add_ExtLine
GO

Create procedure dbo.A_DynamicConfig_Add_ExtLine
	@lineid uniqueidentifier,
	@type int = 7,
	@caption nvarchar(200) = '',	
	@linenum int = NULL,
	@linenumstr nvarchar(20) = NULL,
	@streamid uniqueidentifier,
	@linecode nvarchar(200) = '',
	@serverid uniqueidentifier = '00000000-0000-0000-0000-000000000000'
as
Begin
	Declare @srvid uniqueidentifier
	Set @srvid = @serverid
	if ( @srvid = '00000000-0000-0000-0000-000000000000' )
		Select @srvid = [Id] 
		From A_WorkPlaces 
		Where ( hasfastengine = 1 ) and ( ParentID = '00000000-0000-0000-0000-000000000000' )

	if ( @linenum is NULL )
		Set @linenum = 0
	if ( @linenumstr is NULL )
		Set @linenumstr = cast ( @linenum as nvarchar (10))	

	Insert into A_ServerExtLines ( Id, ServerId, Caption, Type, DialType, CanSimpleOut, CanIP, CanAutoDial, Prefix, SystemNum, Enabled, CanMobile, ExtNumber, ConnectedPBX, StreamId, LineCode, IsDynamicConfig, SystemNumStr )
	Values ( @lineid, @srvid, @caption, @type, 0, 1, 1, 1, '', @linenum, 1, 1, '', 0, @streamid, @linecode, 1, @linenumstr )
End
GO


-------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Admin_Lines_Int_Get' ))
	Drop procedure dbo.A_Admin_Lines_Int_Get
GO

Create Procedure [dbo].A_Admin_Lines_Int_Get
	@id uniqueidentifier
as
begin
   --    .
   --  0  - 
   --    -   (  CTI)

   Declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
   Insert into @groups
	Select Id, Name 
	From A_Groups
   Insert Into @groups ( groupid, groupname )
	Values ( '00000000-0000-0000-0000-000000000000', '' )


   if ( @id = '00000000-0000-0000-0000-000000000000' )
   begin
	Select 
		e.Id,
		w.Name,
		w.Id,
		e.SystemNumStr,
		Cast ( e.Enabled as bit ) as Enabled,		
		Cast ( e.CityStraight as bit ) as CityStraight, 
		e.caption,
		e.ServerId,
		e.Type,
		e.ParentGroupId,
		g.GroupName,
		e.Address,
		e.StreamId,
		st.Name as StreamName,
		e.BusyMode,
		e.LineCode,
		e.Translit,
		e.SipPass
	FROM 
	(	
		Select 	Id,
			SystemNumStr, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address,
			Cast ( NULL as uniqueidentifier ) as StreamId,
			Cast ( NULL as int ) as BusyMode,
			LineCode,
			Cast ( NULL as int ) as Translit,
			Cast ( NULL as nvarchar(100) ) as SipPass
		From A_ServerIntLines

		Union All

		Select 	Id,
			SystemNumStr, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address,
			Cast ( NULL as uniqueidentifier ) as StreamId,
			Cast ( NULL as int ) as BusyMode,
			LineCode,
			Cast ( NULL as int ) as Translit,
			Cast ( NULL as nvarchar(100) ) as SipPass
		From A_ServerUsbLines
		
		Union All

		Select 	Id,
			SystemNumStr, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			Address,
			StreamId,
			BusyMode,
			LineCode,
			Translit,
			SipPass
		From A_ServerSipLines


		Union All

		Select 	Id,
			SystemNumStr, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			Address,
			Cast ( NULL as uniqueidentifier ) as StreamId,
			Cast ( NULL as int ) as BusyMode,
			LineCode,
			Cast ( NULL as int ) as Translit,
			Cast ( NULL as nvarchar(100) ) as SipPass
		From A_ServerVirtualLines
	) e
	
		Inner join A_WorkPlaces w on e.ServerID = w.ID
		Inner join @groups g on e.ParentGroupId = g.GroupId
		Left join A_ServerStreams st on e.StreamId = st.Id

	Order By SystemNumStr
    
   end
   else
   begin
	
	Select 
		e.Id,
		w.Name,
		w.Id,
		e.SystemNumStr,
		Cast ( e.Enabled as bit ) as Enabled,		
		Cast ( e.CityStraight as bit ) as CityStraight, 
		e.caption,
		e.ServerId,
		e.Type,
		e.ParentGroupId,
		g.GroupName,
		e.Address,
		e.StreamId,
		st.Name as StreamName,
		e.BusyMode,
		e.LineCode,
		e.Translit,
		e.SipPass
	
	FROM 
	(	
		Select 
			Id,
			SystemNumStr, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address,
			Cast ( NULL as uniqueidentifier ) as StreamId,
			Cast ( NULL as int ) as BusyMode,
			LineCode,
			Cast ( NULL as int ) as Translit,
			Cast ( NULL as nvarchar(100) ) as SipPass
		From A_ServerIntLines
		
	) e
	
		Inner join A_WorkPlaces w on e.ServerID = w.ID
		Inner join @groups g on e.ParentGroupId = g.GroupId
		Left join A_ServerStreams st on e.StreamId = st.Id

	Where e.ServerId = @id
	Order By SystemNumStr
    end	

end
GO
